# ::: IRC-  v2.4 :::  
#  Quiz.tcl
#  v1.8 by Sergio + new addons
#   v2.0.4 by hex and Drakon and mod Kreon && MOSSs
#    , , " ", -, -
# Quiz@SolNet Edition
# 
# +++ MOD COLORS +++
# 
# +++ MOD NEW STYLE +++


## Game-script ##
	
proc ::tpub::toupper {t} {
return [string toupper $t]
}

proc ::tpub::tolower {t} {
return [string tolower $t]
}
	
###     (c) s7ream
proc ::tpub::numgrp {number} { switch -glob -- "$number" { *11 {return 3} 	*12 {return 3} *13 {return 3} *14 {return 3} 	*1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3}}}
#   
proc putfast {text} {append text "\n"; putdccraw 0 [string length $text] $text}


proc putout {cmd dest msg} { global botnick
	set maxlen [expr 510 - [string length "$botnick![getchanhost $botnick] $cmd $dest :"]]
	while {$msg != ""} {
		set text [expr {[string length $msg] > $maxlen ? [string range $msg 0 [string last \x20 [string range $msg 0 $maxlen]]] : $msg}]
		putfast "$cmd $dest :$text"
		set msg [string trim [string range $msg [string length $text] end]]
	}
}
proc putmsg {nick msg} { putout PRIVMSG $nick $msg }
proc putnot {nick msg} { putout NOTICE $nick $msg }
proc putact {dest msg} { putfast "PRIVMSG $dest :\001ACTION $msg\001" }
proc putpvt {nick chan msg} {
	if {[validchan $chan]} {
		putnot $nick $msg
	} else {
		putmsg $nick $msg
	}
}
###      
proc ::tpub::usage {nick chan cmd {arg ""} {info ""}} {
	set not "\002$cmd\002"
	if {$arg != ""} { append not " $arg" }
	if {$info != ""} { append not " - $info"}
	set aliases ""
	foreach item [lsort [info commands ::tpub::cmd_*]] {
		if {[string match "return \\\[cmd_$cmd * * *\\\]" [string trim [info body $item]]]} { append aliases " [string range $item 12 end]" }
	}
	if {$aliases != ""} {
		append not ". :$aliases"
	}
  putlog "123 $nick $chan $not"
	putpvt $nick $chan ": $not"
	return 0
}
#      
proc ::tpub::checktime {} { variable conf
	if {![info exists conf(timelimit)]} { return 1 }
	foreach item [split $conf(timelimit)] {
		#   ,     
		if {[string is int $item] && [expr int($item) == int([clock format [clock seconds] -format %H])]} {
			return 1
		}
		#     
		if {![regexp {^(\d+(:\d+)?)?-(\d+(:\d+)?)?.*$} $item t1 t1 t2 t2]} {
			putlog "he3hauka: wrong time interval: $item"
			continue
		}
		#    
		if {$t1 == ""} { set t1 "00:00" }
		if {$t2 == ""} { set t2 "24:00" }
		#   
		if {[string is int $t1]} { append t1 ":00" }
		if {[string is int $t2]} { append t2 ":00" }
		#    ..
		set t1 [expr double([string map {: .} $t1])]
		set t2 [expr double([string map {: .} $t2])]
		#  
		set t [expr double([clock format [clock seconds] -format "%H.%M"]) ]
		# ,   
		if {$t >= $t1 && $t <= $t2} { return 1 }
	}
	#   ..
	return 0
}

#   
# question rehash -    ,   
# question get -      ( 
#                 rehash,   ),  :
#                {question {answer answer answer}}
proc ::tpub::question {cmd {text ""}} { variable conf; variable qpos
	switch -exact -- [string tolower $cmd] {
		"count" {
		if {$conf(qmode) eq 1} {
		
			if {![info exists qpos]} { return 0 }
			return [llength $qpos]
		}
		
		if {$conf(qmode) eq 2} {
		if {![info exists qpos]} { return 0 }
		if {[llength $qpos] > 1} {return [llength $qpos]}
			return $qpos
		}
		}
		"rehash" {
			if {[info exists qpos]} { unset qpos }
			set qpos {}
			set ::tpub::qcount 0
			if {[catch {open $conf(fnquestions) r} fileID]} { return 0 }
			while {![eof $fileID]} {
				set pos [tell $fileID]
				incr ::tpub::qcount
				if {[set line [string trim [gets $fileID]]] == ""} { continue }
				if {[string range $line 0 0] == "#"} { continue }
				lappend qpos $pos
			}
			close $fileID
			return [llength $qpos]
		}
		"get" {
		if {$conf(qmode) eq 1} {
		# random question
			if {![info exists qpos] || ![llength $qpos]} {
				putlog "Out of questions, rehashing..."
				if {![question rehash]} {
					putlog "No questions available, eek."
					return {}
				}
			}
			set idx [expr int(rand() * [llength $qpos])]
			set fpos [lindex $qpos $idx]
			set qpos [lreplace $qpos $idx $idx]
			if {[catch {open $conf(fnquestions) r} fileID]} { return {} }
			seek $fileID $fpos start
			set line [gets $fileID]
			set line [split [string trim $line] |]
			set line "[toupper [string range $line 0 0]][string range $line 1 end]"
			close $fileID
			return [list [lindex $line 0] [split [lrange $line 1 end] ,]]
			}
			if {$conf(qmode) eq "2"} {
					set q [open $conf(fnquestions) r]
					set quiz(data) [split [read $q] \n]
					if {[getuser $conf(owner) xtra count] == ""} {
						setuser $conf(owner) xtra count 0
						}
					set quiz(count) [getuser $conf(owner) xtra count]
					set line [lindex $quiz(data) $quiz(count)]
					set qpos [expr [llength $quiz(data)] - $quiz(count)]
					set line [split [string trim $line] |]
					set line "[toupper [string range $line 0 0]][string range $line 1 end]"
					close $q
					setuser $conf(owner) xtra count [incr quiz(count)]
					if {$quiz(count) >= [llength $quiz(data)]} {setuser $conf(owner) xtra count 0; putlog "Out of questions, rehashing..."}
					return [list [lindex $line 0] [split [lrange $line 1 end] ,]]
				}
			}
		
		
		"find" {
			if {$text == ""} {
				error "wrong # args: should be \"questions find pattern\""
			}
			set idx -1
			if {[catch {open $conf(fnquestions) r} fileID]} { return $idx }
			while {![eof $fileID]} {
				if {[string range [set line [gets $fileID]] 0 0] == "#"} { continue }
				incr idx
				if {[lindex [split $line |] 0] == $text} {
					close $fileID
					return $idx
				}
			}
			close $fileID
			return -1
		}
		"del" {
			if {$text == ""} {
				error "wrong # args: should be \"questions del number\""
			}
			if {![string is integer $text]} {
				error "bad option \"$text\": must be an integer"
			}
			if {[catch {open $conf(fnquestions) r+} fileID]} { return 0 }
			while {![eof $fileID]} {
				set pos [tell $fileID]
				if {[string range [gets $fileID] 0 0] == "#"} { continue }
				if {![expr int($text)]} {
					puts -nonewline $fileID "#"
					close $fileID
					return 1
				}
				incr text -1
			}
			close $fileID
		}
		"add" {
			if {$text == ""} {
				error "" "wrong # args: should be \"questions add question test|answer|..\""
			}
			if {[string first | $text] == -1} {
				error "" "wrong question format, must be: \002question text|answer\002[|answer|...]"
			}
			if {[catch {open $conf(fnquestions) a} fileID]} {
				error "" "could not open questions database for writing."
			}
			puts $fileID " [string trim $text]"
			close $fileID
		}
		default {
			error "bad option \"$cmd\": must be rehash, get, find or del"
		}
	}
	return 0
}
#   
proc ::tpub::users {cmd {text {}}} { variable conf
	switch -exact -- $cmd {
		"purge" {
			set killed 0
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				# check if one has a channel record
				if {[chattr $hand] != "-"} { continue }
				foreach chan [channels] {
					if {[haschanrec $hand $chan]} { continue }
				}
				array set usr $xtra
				# linked nick, won't remove anyways
				if {[info exists usr(link)]} { continue }
				if {(![info exists usr(answers)] || $usr(answers) < $conf(minanswers)) || ([info exists usr(last)] && [expr [clock seconds] - $usr(last)] > $conf(maxidle))} {
					incr killed
					deluser $hand
				}
			}
			return $killed
		}
		"list" {
			# list valid users
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
				if {$usr(score) !=0}	 {	lappend users [list $hand $usr(score) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]}
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 2 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
			
		"listmonth" {
			# list valid users
			#putlog "month"
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
				if {$usr(scoremonth) !=0}	 {lappend users [list $hand $usr(scoremonth) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]}
				}
			}

			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"listday" {
			# list valid users
			#putlog "Day"
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(scoreday) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}

			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		
		
			
		"list1" {
			#   
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(answers) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"ansmonth" {
			#     
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(answersmonth) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"list2" {
			#     
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(cont) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"list3" {
			#   
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				if {$usr(quick) == 0} { continue }
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(quick) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -increasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"list4" {
			#     
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(supergames) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"list5" {
			#     
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(anwins) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"list6" {
			#     
			set users {}
			foreach hand [userlist] {
				if {[set xtra [getuser $hand xtra quiz]] == ""} { continue }
				array set usr $xtra
				
				if {[info exists usr(last)] && [expr [clock seconds] - $usr(last)] < 64281600 && ![info exists usr(link)]} {
					lappend users [list $hand $usr(augames) [format %d.%08d $usr(score) [expr 999999 - $usr(answers)]]]
				}
			}
			# sort by place and score
			set sorted {}
			foreach item [lsort -real -decreasing -index 1 $users] {
				lappend sorted [lrange $item 0 1]
			}
			return $sorted
		}
		"exists" {
			return [validuser $text]
		}
		"isintop" {
			if {$text == ""} {
				error "" "wrong # args: should be \"users isintop user\""
			}
			foreach item [lrange [users list] 0 4] {
				if {![string compare -nocase $text [lindex $item 0]]} { return 1 }
			}
		      return 0
		}
	
		"isintopmonth" {
			if {$text == ""} {
				error "" "wrong # args: should be \"users isintop user\""
			}
			foreach item [lrange [users listmonth] 0 4] {
				if {![string compare -nocase $text [lindex $item 0]]} { return 1 }
			}
		      return 0
		}
		
		"isremort" {
			#    ;)
			if {$text == ""} {
				error "" "wrong # args: should be \"users isremort user\""
			}
			
			foreach item [users list] {
				array set usr [users get [lindex $item 0]]
				if {[info exists usr(remort)] && $usr(remort) > 0 && ![string compare -nocase $text [lindex $item 0]]} { return 1 }
				unset usr
			}
			return 0
		}
		"get" {
			if {$text == ""} {
				error "wrong # args: should be \"users get nick\""
			}
			if {![validuser $text]} {
				error "no such user - $text"
			}
			return [getuser $text xtra quiz]
		}
		"set" {
			if {[validuser [set hand [lindex $text 0]]]} {
				setuser $hand xtra quiz [join [lrange $text 1 end]]
				return 1
			} else {
				return 0
			}
		}
		"check" {
			if {$text == ""} {
				error "wrong # args: should be \"users check nick\""
			}
			set hand [lindex $text 0]
			set nick [lindex $text 1]
			set added 0
			#      1 - *!ident@*.host, 2 - *!*@host, 3 - nick!ident@*.
			#      
			if {$hand == "*"} {
				if {![validuser $nick]} { adduser $nick }
			if {![info exists conf(mask)] || $conf(mask)==1} { addhost [set hand $nick] [set host [maskhost [getchanhost $nick]]] }
			if {$conf(mask)==2} { addhost [set hand $nick] [set host "*!*@[lindex [split [getchanhost $nick] "@"] 1]"]}
			if {$conf(mask)==3} { addhost [set hand $nick] [set host "*$nick*!*[lindex [split [getchanhost $nick] "@"] 0]*@*"]}
			if {$conf(mask)==4} { 
			set identfour [lindex [split [getchanhost $nick] "@"] 0]
            regsub -all -- {\~} $identfour {*} identfour
			addhost [set hand $nick] [set host "*!$identfour@[lindex [split [getchanhost $nick] "@"] 1]"]}
			if {$conf(mask)==5} { addhost [set hand $nick] [set host "$nick!*@*"]}
				putlog "::Quiz::   $hand   $host"
			#   ,       +c (common) -  ,     .
			} elseif {[string first c [chattr $hand]] != -1} {
				if {![validuser $nick]} { adduser $nick }
				addhost [set hand $nick] [set host "*!*[getchanhost $nick]"]
				putlog "::Quiz::   $host   $hand"
			}
			#  ,   
			if {$added} {
				global botnick
				setuser $nick comment "(c) $botnick"
				if {[passwdok $hand -]} {
					putmsg $nick "\00315 :)   ,            ,       ,        ;)        ,       ,   ,   ...   ,          ,       ,     : \002pass \002.  !"
				}
			}
			#    
			array set data [getuser $hand xtra quiz]
			if {![info exists data(score)]} { set data(score) 0 }
				if {![info exists data(scoremonth)]} { set data(scoremonth) 0 }	
					if {![info exists data(scoreday)]} { set data(scoreday) 0 }	
			if {![info exists data(cont)]} { set data(cont) 0 }
			if {![info exists data(quick)]} { set data(quick) 0 }
			if {![info exists data(answers)]} { set data(answers) 0 }
				if {![info exists data(answersmonth)]} { set data(answersmonth) 0 }
					if {![info exists data(answersday)]} { set data(answersday) 0 }
			if {![info exists data(supergames)]} { set data(supergames) 0 }
			if {![info exists data(anwins)]} { set data(anwins) 0 }
			if {![info exists data(wins)]} { set data(wins) 0 }
			if {![info exists data(augames)]} { set data(augames) 0 }
			if {![info exists data(last)]} { set data(last) [clock seconds] }
			setuser $hand xtra quiz [array get data]
			setuser $hand XTRA TMPTIME [clock seconds]
			return $hand
		}
		"bla" {
		return bla-bla
		}
		default {
			error "bad option \"$cmd\": must be purge, load, save, list, get or set"
		}
	}
	return 0
}
###    
proc ::tpub::game_time {} { variable game
	if {![info exists game] || ![info exists game(started)]} { return " " }
	set taken [expr ([clock seconds] - $game(started)) / 60]
	set min [expr $taken % 60]
	set hrs [expr ($taken - ($taken % 60)) / 60]
	if {!$taken} { return " " }
	set msg ""
	if {$hrs} { append msg " $hrs [lindex {.   } [numgrp $hrs]]" }
	if {$min} { append msg " $min [lindex {.   } [numgrp $min]]" }
	return [string trim $msg]
}
###   
proc ::tpub::msg_pvt {nick uhost hand text} { global botnick
	if {[string range $text 0 0] == "!"} {
		msg_pub $nick $uhost $hand $nick "=$botnick [string range $text 1 end]"
	}
}

#   "-"
proc ::tpub::ru2en {t} {return [string map { f  \,  d  u  l  t  \`  \;  p  b  q  r  k  v  y  j  g  h  c  n  e  a  \[  w  x  i  m  o  s  \]  \'  \.  z} [string tolower $t]]}
proc ::tpub::en2ru {t} {return [string map {f  \,  d  u  l  t  \`  \;  p  b  q  r  k  v  y  j  g  h  c  n  e  a  \[  w  x  i  m  o  \]  \'  s  \.  z } [string tolower $t]]}

#       
proc ::tpub::filter {text} {
	regsub -all {[;:()\[\]!?.,/\\{}%]} [tolower $text] "" text;
	return [string trim $text]
}
proc ::tpub::okr {t} {
if { [regexp -nocase -- {^(\d+)\.(\d{1,2}).*?$} [string trim $t] grab bb tr] } {set t "$bb.$tr"; return $t}
return 0
}
###    

proc ::tpub::msg_pub {nick uhost hand chan text} { global botnick supergame_nick issupergame isa isanick drinkname qidanswer anagrgame anagrqid auisa auisanick sch; variable conf
	
	#   
	if {[string range $chan 0 0] == "#" && [lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] == -1} {
		#   notice   cmd_start
		return
	}
	#    (???)
	#########set text [encoding convertto [encoding system] $text]
    #      Suzi !
	#   
	regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text
	#  ,   
	if {![string compare -nocase "=$botnick" [lindex [split $text] 0]]} {set text "![join [lrange [split $text] 1 end]]"}
	if {$isa == 1 && $isanick != $nick } {return 0}
	
	#  
	if {[string range $text 0 0] != $conf(pref)} {
		variable game
		if {![info exists game] || $game(chan) != $chan || ![info exists game(question)]} { return }
		set game(cnt_lost) 0
		set supergame_podr 0
		set text2 [en2ru $text]
		
		#putlog "::Quiz:: \037en2ru\037 :: $text2"				
		set text [filter $text]

		set answer [lindex $game(question) 1]

				
					foreach answer [lindex $game(question) 1] {
							if {$qidanswer != "123"} { set answer $qidanswer}
							if {[info exists anagrgame(slovo)] }  { set answer $anagrgame(slovo)}

					
					
					set answer [string tolower $answer]
				###   
		if {[string match -nocase [filter [join $answer]] $text] || [string match -nocase [filter [join $answer]] $text2] } {
				set hand [users check [list $hand $nick]]
				if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
				if {[lsearch -exact $game(ausers) $nick] == -1} {
				lappend game(ausers) $nick
				if {[info exists conf(mpeople)]} {
					putmsg $chan "\00304$nick     !\003"
					timer $conf(tcheck) [list tpub::checkusr $nick]
				} else {
					timer $conf(tcheck) [list tpub::checkusrsilent $nick]
				}
			}
				
			
			if {[lsearch -exact $game(question) "3333"]>0} {
				set time [expr [clock seconds].[string range [clock clicks -milliseconds] [expr [string length [clock clicks -milliseconds]] - 3] end] - $game(asktime)]
				set time [expr $time - $game(ptime)]
				array set usr [users get $hand]
				if {$hand==$game(lst_user)} {putfast "privmsg $chan :\00304[expr {[users isintop $hand] ? "\002$nick\002" : $nick}]\00310      ,   !"
			} else {
		if {[okr $time]!="0" } {
			if { $time < 5 } { 
			putfast "privmsg $chan :\00310[expr {[users isintop $hand] ? "\002$nick\002" : $nick}]    \00304[okr $time]\00310 ." }
		} else {
		   if {$game(creator)!=$hand && ![users isintopmonth $hand] && ![users isintop $hand] && [string first o [chattr [nick2hand $nick]]] == -1} {
			if {[info exists game(bn,$hand)]} { 
				incr game(bn,$hand) 
				} else {
				set game(bn,$hand) 1
				}
			putfast "privmsg $chan :\00310[expr {[users isintop $hand] ? "\002$nick\002" : $nick}],     !      \00304$game(bn,$hand)\00310 [lindex {.   } [numgrp $game(bn,$hand)]]  \00305!\00313."
		  } else {
			putfast "privmsg $chan :\00310[expr {[users isintop $hand] ? "\002$nick\002" : $nick}]   ;)"
			}		
 		  
		}
					}
			unset game(question)
			unset game(ptime)
			unset usr
			return
			}
				if {$hand!=$game(lst_user)} { set game(bonus) 0; set game(bon) 0}
				array set usr [users get $hand]
			
	#			#   
				if {$game(lst_user) == $hand} {
					#putmsg $chan "\$game(lst_cnt)==$game(lst_cnt) $conf(supergame_cnt_tmp) $conf(supergame_cnt)"					
					if {$game(lst_cnt) == 1} {set conf(supergame_cnt_tmp) $conf(supergame_cnt)}
					incr game(lst_cnt)
					
					if {$game(lst_cnt) == $conf(supergame_cnt_tmp)} {
					 set supergame_podr $game(lst_cnt)
					 putlog "supergame_podr - $supergame_podr"
					 set conf(supergame_cnt_tmp) [expr $conf(supergame_cnt_tmp)+$conf(supergame_cnt)]
					}
				      #putlog "\00304DEBUG:    $conf(supergame_cnt_tmp) ."
					
				} else {
					set game(lst_cnt) 1
					set game(lst_user) $hand
				}
				# ,   
				set time [expr [clock seconds].[string range [clock clicks -milliseconds] [expr [string length [clock clicks -milliseconds]] - 3] end] - $game(asktime)]
				set place [place $hand]
				set place1 [place1 $hand]
				
				#     
				if {$time < $usr(quick) || $usr(quick) < 0.1} {
					set usr(quick) [okr $time]
					set bst_time "\00310,     \00314\00310 "
				} 
				#  
				incr usr(answers)
				incr usr(answersmonth)
				incr usr(answersday)
				
				
				set ra [rand 11]	
				if {$game(lst_cnt)>2} { 
					if {[expr $game(lst_cnt) % 2]} { 
						if {$game(bonus)>10} { set game(bonus) 0 } else { incr game(bonus) }
							set game(bon) 1 } else {
					  set game(bon) 0
					}
				}
				
#   
incr game(cnt_won)
set honor ""
set ko 0
foreach item $conf(drank) { 
if {$usr(score)<=$item} { set honor [lindex $conf(rank) $ko]; break}
incr ko } 
if {$honor==""} {set honor $conf(dmax)}

 
set phrasesmol {
","
","
","
","
","
","
","
""
","
","
","
","
","
"..."
","
","
","
","
","
","
","
","
","
","

}

set phraseverotv {
"!  "
"!  "
"!  "
}


#  { }  
	if {([string match *\{* [lindex $game(question) 1]])} {
		set rarange [string length [lindex $game(question) 1]]
		set rarange [incr rarange -3]
		set rans [string tolower [string range [lindex $game(question) 1] 2 $rarange]]
	} else {
		set rans [string tolower [lindex $game(question) 1]]
	}

set game(ptime) "$time"
#  
if {[info exists conf(showansw)] && $conf(showansw)} {
					
if {[info exists game(extra)] && $game(extra) || [info exists game(dex)] && $game(dex) } {
 set nast [rand $conf(rand)]; set ns 0
set ransput ""
putlog "EXTRA"
  if {$nast>[expr $conf(rand) - 5] && $ns == "0"} {
   incr nast "-[expr abs($conf(rand) - 4)]"
   putquick "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]  \00304\002\002$nast\002\002\00310 [lindex {.   } [numgrp $nast]]   ,   !" 
   incr usr(score) "-$nast"
   incr usr(scoremonth) "-$nast"
   incr usr(scoreday) "-$nast"
   users set [list $hand [array get usr]]
   set ns 1
  }
 if {$nast<=[expr abs($conf(rand) - ($conf(rand) - 5))] && $ns == "0"} {
set nast [expr $nast + 4]
putquick "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]     \00304\002\002$nast\002\002\00310 [lindex {.   } [numgrp $nast]] [lindex {.   } [numgrp $nast]]!" 
incr usr(score) $nast
incr usr(scoremonth) $nast
incr usr(scoreday) $nast
users set [list $hand [array get usr]]
set ns 1
 }
if {$nast==[expr $conf(rand) / 5]} {
if {[place $hand]==1} {
set tscore $conf(bonusscore)
putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}],    ,        ,    \00304\002\002$conf(bonusscore)\002\002\00310 [lindex {.   } [numgrp $conf(bonusscore)]]" 
incr usr(score) $tscore
incr usr(scoremonth) $tscore
incr usr(scoreday) $tscore
users set [list $hand [array get usr]]
} else {
set clist [users list]
}
set ns 1
}
if {$nast==[expr $conf(rand) / 4]} {
set clist [users list]
set ns 1
}
if {!$ns} {
set poin [rand 15]; if {$poin<2} {set poin [expr $poin +2]}
putquick "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310     \00304\002\002$poin\002\002\00310 [lindex {.   } [numgrp $poin]] [lindex {.   } [numgrp $poin]]!"
incr usr(score) $poin
incr usr(scoremonth) $poin
incr usr(scoreday) $poin
users set [list $hand [array get usr]]
}
 set game(extra) 0
 catch { unset game(extra) };catch { unset game(dex) }
 
} else { 
set ransput ""
set rscore ""

if {$game(bonus)>0 && $game(bon)==1} {
set linebon $game(bonus)
incr usr(score) [expr $game(points) + $game(bonus)]
incr usr(scoremonth) [expr $game(points) + $game(bonus)]
incr usr(scoreday) [expr $game(points) + $game(bonus)]
users set [list $hand [array get usr]]
} else {
incr usr(score) $game(points)
incr usr(scoremonth) $game(points)
incr usr(scoreday) [expr $game(points) + $game(bonus)]
users set [list $hand [array get usr]]
	}
}

} else {
			
	if {[info exists game(extra)] && $game(extra) || [info exists game(dex)] && $game(dex) } {
	set nast [rand $conf(rand)]; set ns 0
set ransput ""
putlog "EXTRA"
  if {$nast>[expr $conf(rand) - 5] && $ns == "0"} {
   incr nast "-[expr abs($conf(rand) - 7)]"
   putfast "privmsg $chan :\00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310, ,        \00304\002\002$nast\002\002\00310 [lindex {.   } [numgrp $nast]]." 
   incr usr(score) "-$nast"
   incr usr(scoremonth) "-$nast"
   incr usr(scoreday) "-$nast"
   users set [list $hand [array get usr]]
   set ns 1
  }
 if {$nast<=[expr abs($conf(rand) - ($conf(rand) - 5))] && $ns == "0"} {
set nast [expr $nast + 7]
putfast "privmsg $chan :\00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310, !      \00304\002\002$nast\002\002\00310 [lindex {.   } [numgrp $nast]]." 
incr usr(score) $nast
incr usr(scoremonth) $nast
incr usr(scoreday) $nast
users set [list $hand [array get usr]]
set ns 1
 }
if {$nast==[expr $conf(rand) / 5]} {
if {[place $hand]==1} {
set tscore $conf(bonusscore)

users set [list $hand [array get usr]]
} else {
set clist [users list]
}
set ns 1
 
}
if {$nast==[expr $conf(rand) / 4]} {
set clist [users list]
set ns 1

}
if {!$ns} {
set poin [rand 11]; if {$poin<3} {set poin [expr $poin +3]}
putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310,        \00304\002\002$poin\002\002\00310 [lindex {.   } [numgrp $poin]]."
incr usr(score) $poin
incr usr(scoremonth) $poin
incr usr(scoreday) $poin
users set [list $hand [array get usr]]
}
 set game(extra) 0
 catch { unset game(extra) }
 catch { unset game(dex) }

} else { putfast "privmsg $chan :\00310[lindex $phrasesmol [rand [llength $phrasesmol]]] \00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310!    \00304[tolower $rans]\00310,    \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]].\003" 
  if {$game(bonus)>0 && $game(bon)==1} {
    
set linebon $game(bonus)
incr usr(score) [expr $game(points) + $game(bonus)]
incr usr(scoremonth) [expr $game(points) + $game(bonus)]
incr usr(scoreday) [expr $game(points) + $game(bonus)]
users set [list $hand [array get usr]]
} else {
incr usr(score) $game(points)
incr usr(scoremonth) $game(points)
incr usr(scoreday) $game(points)
users set [list $hand [array get usr]]
  }
    }
	}
 array set usr [users get $hand]
set atime [getuser $hand XTRA ATIME]
if {[string trim $atime] == ""} {set atime 0}
setuser $hand XTRA ATIME [expr $atime + $time]
if {$usr(answers) == 1} {
append rscore "\00310.  \00304 \00310  \;).    \00304\002\002$usr(score)\002\002\00310 [lindex {.   } [numgrp $usr(score)]] \00312(\00303\002\002$usr(answers)\00310 [lindex {.   } [numgrp $usr(answers)]]\002\002\00312)\003"
 } else {
append rscore "\00310.    \00304\002\002$usr(score)\002\002\00310 [lindex {.   } [numgrp $usr(score)]] \00312(\00303\002\002$usr(answers)\00310 [lindex {.   } [numgrp $usr(answers)]]\002\002\00312\) \00310(\00304$usr(scoremonth) \00312(\00303\002\002$usr(answersmonth)\002\002\00312\)\00310)\003"
if {[info exists linebon]} {
set rrrr_b ""
if {$linebon > 0} { append rscore " \00310(\00303 \00304\002\002+$linebon\002\002\00310 [lindex {.   } [numgrp $linebon]])"}
if {$linebon < 0} { append rscore " \00310(\00314 \00304\002\002-$linebon\002\002\00310 [lindex {.   } [numgrp $linebon]])"}
unset linebon
}
}

if {$game(lst_user) == $hand} {
if {$game(lst_cnt) > 1} {
append rscore "\00310    \00304\002\002$game(lst_cnt)\002\002\00310  !"
}
}



if {$game(lst_cnt) == 20} {putfast "privmsg $chan :\00310     ?!"}
if {$game(lst_cnt) == 40} {putfast "privmsg $chan :\00310    \00303$nick \00310 \;\)"}
if {$game(lst_cnt) == 60} {putfast "privmsg $chan :\00310    \%\)\)\)"}

 
append rscore "[expr {[info exists bst_time] ? $bst_time : ""}]"

#     
if {$game(lst_user) == $hand} {
if {$game(lst_cnt) > 1 && $game(lst_cnt) > $usr(cont)} {
set usr(cont) $game(lst_cnt)
append rscore "\00310    \00304\00310!"
}
} else {
set game(lst_cnt) 1
set game(lst_user) $hand
}

set rsbon ""

if { $isa != 1 && $qidanswer == "123" && ![info exists anagrgame(slovo)] && $::auisa != 1 } {
putquick "privmsg $chan :\00310[lindex $phrasesmol [rand [llength $phrasesmol]]] \00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310[lindex $phraseverotv [rand [llength $phraseverotv]]] -> \"\002[tolower $rans]\002\" <-,    \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]]$ransput$rscore\003"

set plhand [place $hand]
set pl1hand [place1 $hand]

if { ($plhand < $place) && $place !=0 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 \]        \002\002\00304[place_ext $place [place $hand]]\00310!  ! \:)\003" }
if { ($pl1hand < $place1) && $place1 !=0 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 \]        \002\002\00304[place_ext_mon $place1 [place1 $hand]]\00310!  ! \:)\003" }
if { ($plhand > $place) && $place !=0 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 ]\     ,   \002\002\00304[place_ext [place $hand] $place]\00310!  ,  \;)\003" }

putloglev d * "::Quiz:: PLACE: Total: place_hand=[place $hand] :: place=$place ::: Month: place_hand=[place1 $hand] :: place=$place1"
if { ($pl1hand > $place1) && $place1 !=0 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 ]\    ,   \002\002\00304[place_ext_mon [place1 $hand] $place1]\00310!  ,  \;)\003" }

}


					
if {[info exists msg_cont]} { putfast "privmsg $chan :\00310$msg_cont\003" }
set ko 0
set honor1 ""
foreach ite $conf(drank) { 
if {$usr(score)<=$ite} { set honor1 [lindex $conf(rank) $ko]; break}
incr ko } 
if {$honor1!=$honor} {
if {![info exists conf(rscore)] || $usr(score)<$conf(rscore)} { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \00304$honor1\00310!\003"}
}

if {$isa == 1} {
					 putfast "privmsg $chan :\00310[lindex $phrasesmol [rand [llength $phrasesmol]]] \00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310!   \00308-\00310!   -> \"\002$rans\00310\002\" <-,    \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]]$ransput$rscore\003" 
					 set isa 0
					 set isanick "123"
					 incr usr(supergames)
					 putfast "privmsg $chan :\00303$nick \00310\00307 $usr(supergames)\00310 [lindex {.   } [numgrp $usr(supergames)]].\003"

					if { [place $hand] < $place } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 \]        \002\002\00304[place_ext $place [place $hand]]\00310!  ! \:)\003" }
					if { [place1 $hand] < $place1 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 \]        \002\002\00304[place_ext_mon $place1 [place1 $hand]]\00310!  ! \:)\003" }
					} else {
					 if {$qidanswer != "123"} { 
				        putfast "privmsg $chan :\00310[lindex $phrasesmol [rand [llength $phrasesmol]]] \00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310!     -> \"\002$qidanswer\002\00310\" <-  \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]]  \00304 $game(points)\00310 [lindex {.   } [numgrp $game(points)]]$ransput$rscore\003"
if { [place $hand] < $place } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 \]        \002\002\00304[place_ext $place [place $hand]]\00310!  ! \:)\003" }
if { [place1 $hand] < $place1 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 \]        \002\002\00304[place_ext_mon $place1 [place1 $hand]]\00310!  ! \:)\003" }
} 
					 
					 if {[info exists anagrgame(slovo)] && $answer == "$anagrgame(slovo)"} { 
				        putfast "privmsg $chan :\00310[lindex $phrasesmol [rand [llength $phrasesmol]]] \00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310!    -> \"\002$anagrgame(slovo)\002\"\00310 <-  \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]]  \00304 $game(points)\00310 [lindex {.   } [numgrp $game(points)]]$ransput$rscore\003"
					    incr usr(anwins)
						 putfast "privmsg $chan :\00303$nick \00310\00307 $usr(anwins)\00310 [lindex {.   } [numgrp $usr(anwins)]].\003"

						unset anagrgame(slovo)
if { [place $hand] < $place } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 \]        \002\002\00304[place_ext $place [place $hand]]\00310!  ! \:)\003" }
if { [place1 $hand] < $place1 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 \]        \002\002\00304[place_ext_mon $place1 [place1 $hand]]\00310!  ! \:)\003" }
	 set isa 0
						
					 }
					  set isa 0
					  set isanick "123"
		 			 if {![info exists usr(wins)]} { set usr(wins) 0 }
					}

if {$auisa == 1 && $nick == $auisanick} {
 putfast "privmsg $chan :\00310, \00303[expr {[users isremort $hand] ? "\002$nick\002" : $auisanick}]\00310!   \00304-\00310!   -> \"\002$rans\00310\002\" <-,    \00304\002\002[okr $time]\002\002\00310 [lindex {.   } [numgrp $time]]$ransput$rscore\003" 

					if {[info exists sch] && $sch >0} {set sch 0}
					incr usr(augames)
					putfast "privmsg $chan :\00303$auisanick \00310\00307 $usr(augames)\00310 [lindex {.   } [numgrp $usr(augames)]].\003"
if { [place $hand] < $place } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $auisanick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 \]        \002\002\00304[place_ext $place [place $hand]]\00310!  ! \:)\003" }
if { [place1 $hand] < $place1 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $auisanick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 \]        \002\002\00304[place_ext_mon $place1 [place1 $hand]]\00310!  ! \:)\003" }
					set auisa 0
					set auisanick "000"
set ::tpub::auusers {}
			##################################################
			set sn {}
			foreach au_user [lindex [chanlist $chan]] {
			lappend sn $au_user
			set a1 0
			set a2 ""
			while {$a1 < [llength $sn]} {
			append a2 "v"
			incr a1
			}
			}
		 putserv "mode $chan -m+$a2 [join [lrange $sn 0 9]]"
		 if {[expr [string length $a2] >10]} {	 putserv "mode $chan +$a2 [join [lrange $sn 10 19]]"}
		 set a2 ""
			##################################################
				}
				
				if {$auisa == 1 && $nick != $auisanick} {
					if {[info exists sch] && $sch >0} {set sch 0}
					incr usr(score) [expr -$game(points) *2]
					incr usr(scoremonth) [expr -$game(points) *2]
					incr usr(scoreday) [expr -$game(points) *2]
				
				 putfast "privmsg $chan :\00303[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\00310,      !     \00304 $game(points)\00310 [lindex {.   } [numgrp $game(points)]]" 

				
if { [place $hand] > $place } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 ]\     ,   \002\002\00304[place_ext [place $hand] $place]\00310!  ,  \;)\003" }
if { [place1 $hand] > $place1 } { putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 ]\    ,   \002\002\00304[place_ext_mon [place1 $hand] $place1]\00310!  ,  \;)\003" }
					set auisa 0
					set auisanick "000"
set ::tpub::auusers {}
			##################################################
			set sn {}
			foreach au_user [lindex [chanlist $chan]] {
			lappend sn $au_user
			set a1 0
			set a2 ""
			while {$a1 < [llength $sn]} {
			append a2 "v"
			incr a1
			}
			}
		 putserv "mode $chan -m+$a2 [join [lrange $sn 0 9]]"
		 if {[expr [string length $a2] >10]} {	 putserv "mode $chan +$a2 [join [lrange $sn 10 19]]"}
		 set a2 ""
			##################################################
				}
				##  ..
				if {$game(lst_cnt) == 5} {
					putserv "PRIVMSG $chan :\001ACTION  5   ,  \00304@\00303|-`--,---\003 [expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\001"
				    }
				if {$game(lst_cnt) == 3} {
					putserv "PRIVMSG $chan :\001ACTION    1,5__4]  3    [expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\001"
				    }
				if {$game(lst_cnt) == 7} {
					putserv "PRIVMSG $chan :\001ACTION     7    [expr {[users isremort $hand] ? "\002$nick\002" : $nick}]\001"
				    }
				####

#  
if {(![isvoice $nick $chan] && ![isop $nick $chan]) && (([users isintop $hand] && $usr(score) > 100) || [users isremort $hand])} {
putquick "MODE $chan +v $nick"
putfast "privmsg $chan :\00310[expr {[users isremort $hand] ? "\002$nick\002" : $nick}] [expr {[users isremort $hand] ? " ,    !" : "    !"}]\003"
}
set usr(last) [clock seconds]
			## store back
			
			
			users set [list $hand [array get usr]]
			lappend game(question) "3333"
			#
			#
			if {[info exists usr(wins)] && $usr(wins) > 0 } { set stavkamax 250 } else { set stavkamax 30 }

			if { $supergame_podr != 0 } {
		#	putlog "supergame_podr2 - $supergame_podr"
			unset game(question)
			putfast "privmsg $chan \00303$nick\00310    \00304-\00310!  \00303! <>\00310,    \00303!\00310,  .  \00303 10\00310 \00303 $stavkamax\00310  ( \00303 10\00310 ).     \00304\002\002 $conf(supergame_off)\00310 .\003"
			set hint1d 0
			killtm
			utimer $conf(supergame_off) "supergame_off $nick $chan $conf(nextq) $conf(supergame_off)"
			set supergame_nick $nick
			set issupergame 1
			return 0
			} else	{ 	
			
			#putfast "privmsg $chan :\00310 nax   $conf(nextq) !\00"
			set hint1d 0
			killtm
			utimer $conf(nextq) ::tpub::tmr_ask
			
			return 0
			
			
			## end of store back ..
		}
}	
	
		
		#  
		if {[info exists conf(nightmare)] && [llength [split $text]] == 1 && ![catch {array set usr [users get $hand]}]} {
			#       ( 1 )
			if {$game(points) == 2 && [info exists usr(score)] && $usr(score)} {
				incr usr(score) -1
				incr usr(scoremonth) -1
				incr usr(scoreday) -1
				users set [list $hand [array get usr]]
			}
		}
		
		return
		}
	}
	
	set cmd [string tolower [string range [lindex [split $text] 0] 1 end]]
	set text [join [lrange [split $text] 1 end]]
	#  
	if {[info commands ::tpub::cmd_$cmd] == ""} { return }
	#    (    )
	set user [expr {$hand == "*" ? "$nick!$uhost" : $hand}]
	# ...
	set status "OK"
	if {[catch {::tpub::cmd_$cmd $nick $chan $text} res]} {
		set status "ERROR"
putlog "$res"
		if {$hand != "*" && [string first o [chattr $hand]] != -1} {
			global errorCode errorInfo
			putfast "notice $nick :   \002!$cmd\002: $errorInfo"
		}
		set res 1
	} elseif {$res == "deny"} {
		set status "DENIED"
		putfast "notice $nick :       \002!$cmd\002."
	}
	if {$res != 0} {
		set msg "%$user% $cmd $text"
		if {$status != "OK"} { append msg " -- $status" }
		putlog $msg
	}
}

proc ::tpub::place_ext {i1 i2} {
		foreach a [lrange [users list] $i2 $i1] {
		lappend b [lindex $a 0]
		}
		if {[llength $b] >6} {return [join [lrange $b 0 6] ", "]...}
		if {[llength $b] eq 1} {return [join [lrange $b 0 6] ""]}
	return [join [lrange $b 0 end-1] ", "]
}

proc ::tpub::place_ext_mon {i1 i2} {
		foreach a [lrange [users listmonth] $i2 $i1] {
		lappend b [lindex $a 0]
		}
		if {[llength $b] >6} {return [join [lrange $b 0 6] ", "]...}
		if {[llength $b] eq 1} {return [join [lrange $b 0 6] ""]}
	return [join [lrange $b 0 end-1] ", "]
}


proc ::tpub::place1 {hand} {
	set place -1
	if {![info exists list]} { set list [users listmonth] }
	for {set i 0} {$i < [llength $list]} {incr i} {
		if {![string compare -nocase $hand [lindex [lindex $list $i] 0]]} {
			set place $i
			break
		}
	}
	incr place
return $place
}


proc ::tpub::place2 {hand} {
	set place -1
	if {![info exists list]} { set list [users listday] }
	for {set i 0} {$i < [llength $list]} {incr i} {
		if {![string compare -nocase $hand [lindex [lindex $list $i] 0]]} {
			set place $i
			break
		}
	}
	incr place
return $place
}

proc ::tpub::place {hand} { 
	set place 0
regsub -all -- {\[} $hand {\[} hand
regsub -all -- {\]} $hand {\[} hand
regsub -all -- {\\} $hand {\\} hand
regsub -all -- {\-} $hand {\-} hand
regsub -all -- {\|} $hand {\|} hand
regsub -all -- {\{} $hand {\{} hand
regsub -all -- {\}} $hand {\}} hand
regsub -all -- {\*} $hand {\*} hand
if {![isnumber $hand]} {
	if {[lsearch -regexp [::tpub::users list] "(?i)$hand"]!="-1"} {set place [expr [lsearch -regexp [::tpub::users list] "(?i)$hand"] + 1]}
return $place
	} else {
if {$hand <= [llength [::tpub::users list]] } { 
set hand [expr $hand - 1]
return [lindex [::tpub::users list] $hand] 
}
}
}

proc ::tpub::remort {nick uhost hand chan} {
	variable game
	variable conf
array set usr [users get $hand]
putfast "privmsg $chan :\00310$nick  \002\00304\00310\002.\003"
putfast "privmsg $chan :\00310$nick   [expr {![info exists usr(remort)] ? "\00304\003" : "\00304[expr $usr(remort) + 1]-\003"}] \00310! \00304$nick\00310,   !\003"
set usr(score) 0
if {![info exist usr(remort)]} { set usr(remort) 1 } else {
incr usr(remort)
}
set usr(score) 0
users set [list $hand [array get usr]]
}
### help
proc ::tpub::cmd_help {nick chan text} { variable conf
	if {[info commands ::tpub::cmd_$text] != ""} {
		return [::tpub::cmd_$text $nick $chan ?help?]
	}
	set cmds ""
	foreach item [lsort [info commands ::tpub::cmd_*]] {
		if {![string match "return \\\[cmd_* * * *\\\]" [string trim [info body $item]]]} { append cmds " ![string range $item 12 end]," }
	}
	set msg "  ([llength $cmds]):$cmds.               \002!help \002"
	putpvt $nick $chan "$msg.\003"
}
### mytitul
proc ::tpub::cmd_mytitul {nick chan text} { variable conf
	 if {$text == "?help?"} { return [usage $nick $chan mytitul "?...?" " ,     !/!     .         none."] }
		set hand [nick2hand $nick]
		if {$hand == "" || $hand == "*"} {putfast "notice $nick :    ."; return}
		array set usr [users get $hand]
		if {![users isremort $hand]} {
			putpvt $nick $chan "  ,      ."
			return
		}
		if {[lindex $text 0]!="none"} {
set tremort [lindex $text 0]
		set usr(tremort) $tremort
		users set [list $hand [array get usr]]
		putpvt $nick $chan "    \"$tremort\""
		} else {
		unset usr(tremort)
		users set [list $hand [array get usr]]
		putpvt $nick $chan "  ."
		}
		
}
### dump
proc ::tpub::cmd_dump {nick chan text} {
	if {$text == "" || $text == "?help?"} { return [usage $nick $chan dump text "     ."] }
	if {[string first n [chattr [nick2hand $nick]]] == -1} { return deny }
	putfast $text
}
###        
proc ::tpub::cmd_rehash {nick chan text} {
	if {$text == "?help?"} { return [usage $nick $chan rehash "" "     .      ."] }
	if {[string first m [chattr [nick2hand $nick]]] == -1} { return deny }
	if {$text == "questions"} {
		putfast "notice $nick :rehashing questions..."
		question rehash
		return [cmd_next $nick $chan $text]
	}
	putfast "notice $nick : ..."
	rehash
}
###    
proc ::tpub::cmd_jump {nick chan text} {
	if {$text == "?help?" || $text == ""} { return [usage $nick $chan jump "" "    "] }
	if {[string first m [chattr [nick2hand $nick]]] == -1 } { return deny }
	putfast "notice $nick :jumping..."
	jump [lindex [split $text] 0]
}
###  
proc ::tpub::cmd_restart {nick chan text} {
	if {$text == "?help?"} { return [usage $nick $chan restart "" "  ,       ."] }
	if {[string first n [chattr [nick2hand $nick]]] == -1} { return deny }
	restart
}
proc ::tpub::cmd_ {nick chan text} { return [cmd_extra $nick $chan $text] }
proc ::tpub::cmd_extra {nick chan text} {
	variable game
if {[string first m [chattr [nick2hand $nick]]] == -1} { return deny }
#if {$conf(modset) eq 1} {putfast "MODE $chan +c"}
putfast "privmsg $chan :\00308\00310!    \00304-\00310!"	
#if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
set game(dex) 2
}
#############################################################################################################
###  
proc ::tpub::cmd_append {nick chan text} {
	if {[llength $text] < 2} { return [usage $nick $chan append "user_who user_to" "      ,  "] }

	if {[string first m [chattr [nick2hand $nick]]] == -1} { return deny }

	set h1 [lindex [split $text] 0]
	set h2 [lindex [split $text] 1]

	if {![validuser $h1]} {
		putnot $nick " $h1  ."
		return 0
	}

	if {$h1 == $h2} {
		putnot $nick "     ."
		return 0
	}

	array set user1 [users get $h1]
	array set user2 [users get $h2]

	# 
	catch { incr user2(score) $user1(score) }

	# 
	catch { incr user2(answers) $user1(answers) }

	#   .. 
	catch { incr user2(scoremonth) $user1(scoremonth) }
	
	#  
	catch { if {$user1(quick) < $user2(quick) && $user1(quick)} { set user2(quick) $user1(quick) } }

	#  ..
	catch { if {$user1(cont) > $user2(cont)} { set user2(cont) $user1(cont) } }

	# 
	catch { if {$user2(email) == "" && $user1(email) != ""} { set user2(email) $user1(email) } }

	# 
	catch { if {$user2(memo) == "" && $user1(memo) != ""} { set user2(memo) $user1(memo) } }

	#   
	catch { if {$user1(last) > $user2(last)} { set user2(last) $user1(last) } }

	users set [list $h1 {}]
	users set [list $h2 [array get user2]]

	putfast "notice $nick :   $h1 ,       $h2."
}
###  
proc ::tpub::cmd_rename {nick chan text} {
	if {[llength $text] < 2} { return [usage $nick $chan rename "nick_from nick_to" "  ."] }
	
	if {[string first o [chattr [nick2hand $nick]]] == -1} { return deny }
	set nick1 [lindex [split $text] 0]
	set nick2 [lindex [split $text] 1]
	if {![validuser $nick1]} {
		putfast "notice $nick : $nick1  ."
		return 0
	}
	if {[validuser $nick2] && [string compare -nocase $nick1 $nick2]} {
		putfast "notice $nick : $nick2  ."
		return 0
	}
	chhandle $nick1 $nick2
	putfast "notice $nick : $nick1    $nick2."
}
proc ::tpub::cmd_ {nick chan text} { return [cmd_chgmyname $nick $chan $text] }
proc ::tpub::cmd_chgmyname {nick chan text} {
	if {[llength $text] < 1 } { return [usage $nick $chan chgmyname "newnick" "    ."] }
	if {$text == "?help?"} { return [usage $nick $chan chgmyname "newnick" "    ."]  }
	set hand [nick2hand $nick]
	set nick1 [string trim [lindex $text 0]]
	if {![validuser $hand]} {
		putfast "notice $nick : $hand  ."
		return 0
	}
	if {[validuser $nick1] && [string compare -nocase $nick $nick1]} {
		putfast "notice $nick : $nick1  ."
		return 0
	}
	chhandle $hand $nick1
	putfast "notice $nick : $hand    $nick1."
}
###    
proc ::tpub::cmd_ {nick chan text} { return [cmd_version $nick $chan $text] }
proc ::tpub::cmd_version {nick chan text} { variable game; variable conf
	global version tcl_patchLevel
	if {[info exists game] && $chan == $game(chan)} {
		putfast "notice $nick :$conf(game_info)"
	} else {
		putact $chan "-  $conf(game_info)"
	}
}
###  
proc ::tpub::cmd_list {nick chan text} {
	if {$text == "?help?"} { return [usage $nick $chan list "" "   ,    ."] }
	if {[string first o [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	if {![llength [set users [users list]]]} {
		putpvt $nick $chan "   ."
	} else {
		set lst "(: [llength $users])"
		foreach item $users { append lst " [lindex $item 0]([lindex $item 1])" }
		putpvt $nick $chan "$lst."
	}
}
###    
proc ::tpub::cmd_ {nick chan text} { return [cmd_forget $nick $chan $text] }
proc ::tpub::cmd_forget {nick chan text} {
	if {$text == "" || $text == "?help?"} { return [usage $nick $chan forget "" "    ."] }
	if {[string first o [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	set user [nick2hand $nick]
	if {![validuser $text]} {
		putfast "notice $nick :    $user ."
		return 0
	}
	users set [list $text {}]
	putact $chan " ,  -   $text"
}
###   
proc ::tpub::cmd_raw {nick chan text} {
	if {$text == "" || $text == "?help?"} { return [usage $nick $chan raw "" "     \"\" "] }
	if {[string first o [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	if {![validuser $text]} {
		putfast "notice $nick : $text  ."
		return 0
	}
	if {[set xtra [users get $text]] == ""} {
		putfast "notice $nick :   $text ."
		return 0
	}
	putpvt $nick $chan "raw($text): [join $xtra]"
}
###  
proc ::tpub::cmd_set {nick chan text} {
	if {[llength [split $text]] < 2} { return [usage $nick set "  ??" "     (         \002!raw\002),     "] }
	if {[string first n [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	if {![validuser [set user [lindex [split $text] 0]]]} {
		putfast "notice $nick : \002$user\002  ."
		return 0
	}
	set para [lindex [split $text] 1]
	set data [lrange [split $text] 2 end]
	array set usr [users get $user]
	if {$data == ""} {
		if {[info exists usr($para)]} { unset usr($para) }
		putfast "notice $nick :  $para   $user ."
	} else {
		set usr($para) $data
		putfast "notice $nick :  $para   $user  : $data"
	}
	users set [list $user [array get usr]]
	users check [list $user $nick]
}
###  
proc ::tpub::cmd_memo {nick chan text} {
	if {$text == "" || $text == "?help?"} { return [usage $nick $chan memo " ,   ,     "] }
	if {[set hand [nick2hand $nick]] == "*"} {
		putnot "       (     )."
		return 0
	}
	array set user [users get $hand]
	if {$text == ""} {
		if {[info exists user(memo)]} {
			putfast "notice $nick : : $user(memo)"
		} else {
			putfast "notice $nick :  ."
		}
		return 0
	} elseif {($text == "none") || ($text == "")} {
		if {[info exists user(memo)]} { unset user(memo) }
		putfast "notice $nick : ."
	} else {
		set user(memo) [string range $text 0 199]
		putfast "notice $nick :   : $user(memo)"
	}
	users set [list $hand [array get user]]
}
###  -
proc ::tpub::cmd_email {nick chan text} {
	if {$text == "" || $text == "?help?"} { return [usage $nick $chan email "" "  e-mail ,  , ,   "] }
	if {[set hand [nick2hand $nick]] == "*" || ![validuser $hand]} {
		putfast "notice $nick :         (,      )."
		return 0
	}
	array set user [users get $hand]
	if {$text == ""} {
		if {![info exists user(email)]} {
			putfast "notice $nick :    ."
		} else {
			putfast "notice $nick :   : $user(email)"
		}
		return 0
	} elseif {$text == "none" || $text == ""} {
		if {[info exists user(email)]} { unset user(email) }
		putfast "notice $nick :     ."
	} else {
		set user(email) [lindex [split $text] 0]
		putfast "notice $nick :      $user(email)"
	}
	users set [list $hand [array get user]]
}
###  
proc ::tpub::cmd_cnfhn {nick chan text} { return [cmd_start $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_start $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_start $nick $chan $text] }
proc ::tpub::cmd_st {nick chan text} { return [cmd_start $nick $chan $text] }
proc ::tpub::cmd_start {nick chan text} { variable game; variable conf
	global server network botnick qidanswer tempqid anagrqid lock sch augamecount
	set sch 0
	if {$text == "?help?"} { return [usage $nick $chan start "" "    ,     ."] }
	if {[info exists game] && [info exists game(qid)]} {
		if {$game(chan) == $chan} {
			putfast "notice $nick :   :)"
		} else {
			putfast "privmsg $chan :$nick,      $game(chan),   ;)"
		}
		return
	}
	if {![set ::tpub::qcount] && ![question rehash]} {
		putfast "privmsg $chan :$nick,  ,       ,   ..."
		return
	}
	if {[lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] == -1} {
		putfast "privmsg $chan :$nick,      ,  $conf(channels)"
		return 0
	}
	#if {![checktime]} {
	#putfast "privmsg $chan :\00303$nick\00310,     ? :)    !\017"
	#	return 0
	#}
	if {![checktime]} {
		putfast "privmsg $chan :\002\00304 ! Password required.\017"
		return 0
	}
	variable g
	if {![info exists g]} {set g ""}
	if {[info exists conf(mpeople)] && [llength $g] < $conf(mpeople)} {
		putfast "privmsg $chan :$nick,     ,      \00304[llength $g] [lindex {.   } [numgrp [llength $g]]]\003,   \00304$conf(mpeople)\003.    \00304!\003."
		return 0
			}
	if {$lock ==1 } {
		putfast "notice $nick :     .  ..."
		return 0
	}
	if {[info exists ::runcity] && $::runcity eq 1} {putfast "privmsg $chan :$nick, \002  \037\037\002!"; return}
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
	putfast "privmsg $chan :\00310 \00303\00310!    \00304\002\002[set ::tpub::qcount]\002\002\00310 [lindex {.   } [numgrp [set ::tpub::qcount]]],   \00304 [set count [question count]]\00310. \002\00303!\002\003"
	
#     ,  
	#set hand [users check [list [nick2hand $nick] $nick]]
	set hand [nick2hand $nick]
	if {$hand == "*"} { set hand [users check [list [nick2hand $nick] $nick]]}
	#if {$hand == "*"} { set hand [users check $nick]}
	
	# 
	set game(chan) $chan				;# 
	set game(creator) $hand				;# ,   ( !stop)
	set game(started) [clock seconds]	;#   
	set game(cnt_lost) 0				;#   
	set game(cnt_won) 0					;#   
	set game(qid) 0						;#   
	set game(lst_user) ""				;#     
	set game(lst_cnt) 0					;#     
	set tempqid 0
	set anagrqid 0
	set augamecount 0
	set qidanswer "123"
	set game(bonus) 0		
	set game(bon) 0			
	set game(extra) 0
	set game(ausers) ""
	if {[info exists isau] && $isau !=0} {set isau 0}
	if {[info exists sch] && $sch !=0} {set sch 0}
	if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	set ::tpub::auusers {}
	#   
	after 5000 ::tpub::tmr_ask
}
###    
proc ::tpub::cmd_ {nick chan text} { return [cmd_repeat $nick $chan $text] }
proc ::tpub::cmd_repeat {nick chan text} { variable game
	if {$text == "?help?"} { return [usage $nick $chan repeat "" "  ,   ."] }
	if {![info exists game]} {
		putfast "privmsg $chan :$nick,    -  \002!\002"
		return 0
	}
	if {![info exists game(question)]} {
		putfast "notice $nick :    ."
		return 0
	}
	putfast "notice $nick : : [lindex $game(question) 0]"
	return 0
}
##############################################################################################################################
proc ::tpub::cmd_no {nick chan text} { return [cmd_no $nick $chan $text] }
proc ::tpub::cmd_ytn {nick chan text} { return [cmd_no $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_no $nick $chan $text] }
proc ::tpub::cmd_no {nick chan text} { variable game; variable conf
	global supergame_nick issupergame drinkname
	if {"$chan $text" == "? ?"} { return [usage $nick no "" "   "] }
	 #putfast "privmsg $chan $supergame_nick $issupergame "
	 if { $issupergame != 1 || $supergame_nick != $nick} { return 0}
	 if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
	 putfast "privmsg $chan :\00303$nick\00304 \00310  \00304-\00310."
	 set supergame_nick "123"
	 set issupergame 0
	 set game(lst_cnt) 0
	 set game(bonus) 0		
	 set game(bon) 0
	 ###putfast "privmsg $chan :\00310   $conf(nextq) !\00"
	 utimer $conf(nextq) ::tpub::tmr_ask
}
proc ::tpub::cmd_yes {nick chan text} { return [cmd_yes $nick $chan $text] }
proc ::tpub::cmd_lf {nick chan text} { return [cmd_yes $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_yes $nick $chan $text] }
proc ::tpub::cmd_yes {nick chan text} { variable game; variable conf
	global supergame_nick issupergame isa isanick isastavka sghand au_nick isau auisa auisanick austavka auhand sch
	###  ..
	if {[info exists isau] && $isau eq 1} {
	if {"$chan $text" == "? ?"} { return [usage $nick yes "" " -   .           .  :  10  30 "] }
if { $isau == 1 && [info exists game(question)] } {unset game(question)}
	if {![info exists game] || $game(chan) != $chan } {
	putlog "st 0"
		return 0
	}
	regsub -all -- {\<} $text "" text
	regsub -all -- {\>} $text "" text
	set winnerhand [nick2hand $nick]
	array set user [set xtra [users get $winnerhand]]
	set args [lindex $text 0]
	if {![isnumber $args] && $args != "" || $args < 0 } {
		putfast "notice $nick : $args    ."
		return 0
	}
	if { $isau != 1 } { putlog "st 1"; return}
	if {[expr $args <1]} {set args 1}
	set lnarg [string length $args]
	if {$lnarg >3} {putserv "NOTICE $nick :\00310  .    1-999"; return}
	if {$args == ""} { putmsg $game(chan) "\00310    \00304$nick\00310. \00307! <>"; return 0
	} else {
	#set ::tpub::auusers [list]
	# set aufile [open "au_st.dat" a+]
	if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
	 putmsg $game(chan) "\00303$nick\00310,        \00304$args\00310.\003"
	# puts $aufile "$args $nick"
	  lappend ::tpub::auusers "$args $nick"
	  
	  putlog "\002auusers\002: [lindex $::tpub::auusers]"
	
	# close $aufile
	
	 }
	 
	 if {[info exists sch] && $sch > 0} {return 0}
	 after 10000 [list ::tpub::au_run $nick $chan $args]
	 incr sch
	 
	 }
	 
	 ## - ..
	 if {[info exists issupergame] && $issupergame eq 1} {} else {return}
	if {"$chan $text" == "? ?"} { return [usage $nick yes "" " -   .           .  :  10  30 "] }
	if {![info exists game] || $game(chan) != $chan || [info exists game(question)]} {
		return 0
	}
	set winnerhand [nick2hand $nick]
	array set user [set xtra [users get $winnerhand]]
	set args [lindex $text 0]
	if {![isnumber $args] && $args != "" || $args < 0 } {
		putfast "notice $nick : $args    ."
		return 0
	}
	if { $issupergame != 1 || $supergame_nick != $nick} { return 0}
	set lnarg [string length $args]
	if { $lnarg > 3 } {
	 putfast "notice $nick :  .   ."
	 return 0	
	}
	if {$args == ""} {
	 set game(points) 10
	} else {
	 set game(points) $args
	  if {[info exists user(wins)] && $user(wins) > 0 } {
	    if { $args > 250 } { set game(points) 250 }	
	  } else {	
	   if { $args > 30 } { set game(points) 30 }
	  }
	 if { $args < 10 } { set game(points) 10 }
	}
	#putfast "privmsg $chanDEBUG: : $args : $game(points)"
	killtm	
	set supergame_nick "123"
	set issupergame 0
	set game(hint1d) 0
	incr game(qid)
	set game(question) [question get]
	set game(asktime) [clock seconds]
	#incr game(qid)
	#    
	if {([string match *\{* [lindex $game(question) 1]])} {
	    #     1
	    set lln [string length [lindex $game(question) 1]]
	    set lln [incr lln -4]
	    set ln "$lln [lindex {.   } [numgrp $lln]] \00304( )\00307"
	} else {
	    #    1
	    set ln "[string length [lindex $game(question) 1]] [lindex {.   } [numgrp [string length [lindex $game(question) 1]]]]\00307"
	}
	if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
	putfast "privmsg $game(chan) :\00308-\00310 \00303 $nick\00310 ! :\00304 $game(points)\00310 [lindex {.   } [numgrp $game(points)]].\003"
	putmsg $game(chan) "\00310\00308 -\00312(#$game(qid)):\00312 [anticheat [lindex $game(question) 0]]\00307 \($ln\)\003"
	putmsg $game(chan) "\00304, \00303$nick\00310!   \00304 $conf(anstime)\00310 ."
#	putmsg $game(chan) "\00303$nick\00310,        .  ,  ,     \00307! <//>\00310.       !"
#	set endknb 0
	set isa 1
	set isanick "$nick"
	set sghand [nick2hand $isanick]
	set isastavka $game(points)
	#putlog "$isa $isanick"
	utimer $conf(anstime) [list ::tpub::tmr_next $game(qid)]
	### -
	# ...
}


proc ::tpub::cmd_lock {nick chan text} { return [cmd_lock $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_lock $nick $chan $text] }
proc ::tpub::cmd_lock {nick chan text} { variable game; variable conf
	global lock
	if {"$chan $text" == "? ?"} { return [usage $nick lock "" " .      !"] }
	if {[info exists game]} {
		return 0
	}
	if {[string first m [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	set lock 1	
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
      putfast "privmsg $chan :\00310 \00304\002\002\00310."
	  if {$conf(modset) eq 1} {putfast "MODE $chan +c"}
}
proc ::tpub::cmd_unlock {nick chan text} { return [cmd_unlock $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_unlock $nick $chan $text] }
proc ::tpub::cmd_unlock {nick chan text} { variable game; variable conf
	global lock
	if {"$chan $text" == "? ?"} { return [usage $nick unlock "" " ."] }
	if {[info exists game]} {
		return 0
	}
	if {[string first m [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1} { return deny }
	set lock 0	
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
      putfast "privmsg $chan :\00310 \00303\002\00310\002.   \002!\002."
	  if {$conf(modset) eq 1} {putfast "MODE $chan +c"}
}
###################################################################################################################################
###  
proc ::tpub::cmd_ {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_\[ {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_X {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_x {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_h {nick chan text} { return [cmd_hint $nick $chan $text] }
proc ::tpub::cmd_hint {nick chan text} { variable game; variable conf
	global isa isanick qidanswer anagrgame auisa auisanick
	if {$text == "?help?"} { return [usage $nick $chan  "" "    ,    5 ,       20 .            (3 )."] }
	if {![info exists game] || $game(chan) != $chan || ![info exists game(question)]} {
		return 0
	}
	#if {[info exists conf(thint)]} {
	#	return 0
	#}
	
	if {[info exists isa] && $qidanswer != "123" } {
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
	putfast "privmsg $chan :\00310,  ;)"; return 0
	}
	
	if {[info exists isa] && $isa == "1" } {
	putfast "notice $nick :\00304      -!"; return 0
	}
	if {[info exists auisa] && $auisa == "1" } {return 0}
	
#	if {[info exists anagrgame(slovo)]} {
#	return 0
#	}
	
	if {[info exists game(alreadyhint)]} {
	#putfast "NOTICE $nick :  !"
	return 0
	}
	set game(alreadyhint) 0
	#     ,      
	::tpub::tmr_hint $game(qid)
	
	return 0
}
###  
proc ::tpub::cmd_ {nick chan text} { return [cmd_next $nick $chan $text] }
proc ::tpub::cmd_lfkmit {nick chan text} { return [cmd_next $nick $chan $text] }
proc ::tpub::cmd_l {nick chan text} { return [cmd_next $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_next $nick $chan $text] }
proc ::tpub::cmd_next {nick chan text} { variable game; variable conf
global anagrgame isau
	if {$text == "?help?"} { return [usage $nick $chan next "" "  .        ."] }
	if {![info exists game]} {
		putfast "privmsg $chan :$nick,    -  \002!\002"
		return 0
	}
	
	#if {$len != 2 } { putfast "notice $nick :    .."; return }
	if {[info exists game(question)] && [lsearch -exact $game(question) "3333"]!=-1} { return }
set areyousure 0
	set hand [nick2hand $nick]
	array set usr [set xtra [users get $hand]]
#############!= $game(creator)
if {![matchattr $hand o] && ![users isintopmonth $hand] && ![users isintop $hand] && (![info exists usr(remort)] || $usr(remort) == 0) && [lindex $game(creator) 0] != $hand} { 
      if {[info exists game(bn,$hand)] && $game(bn,$hand) > 0} { 
         incr game(bn,$hand) -1 
         if {$game(bn,$hand)<=0} { unset game(bn,$hand) } 
      } else { 
         return deny 
      } 
   }
	set game(lst_user) ""
	set game(lst_cnt) 0
	set game(bonus) 0
	set game(bon) 0
	if {![info exists game(question)]} { putfast "NOTICE $nick :    .   \;\)"; return 0 }
	if {[info exists isau] && $isau eq 1} { putfast "NOTICE $nick :  -!"; return 0}
	

#putfast "privmsg $game(chan) :\00310 \00304 $nick\00310  ...\003"
	
	
	
	tmr_next $game(qid)
	if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	set isa 0
}
###  
proc ::tpub::cmd_ {nick chan text} { return [cmd_stop $nick $chan $text] }
proc ::tpub::cmd_cnjg {nick chan text} { return [cmd_stop $nick $chan $text] }
proc ::tpub::cmd_stop {nick chan text} { variable game; variable conf
global botnick auisa isa
	if {$text == "?help?"} { return [usage $nick $chan stop "" "   .   ,     ,  ."] }
	if {[info exists isa] && $isa == 1 || [info exists auisa] && $auisa == 1} {return}
	if {![info exists game] || ![info exists game(qid)]} {
	  if {$botnick==$nick} { return 0 } else {
		putfast "privmsg $chan :$nick, Quiz not running - use \002!\002"
		return 0
	  }
	}
	set hand [nick2hand $nick]
	array set usr [set xtra [users get [nick2hand $nick]]]
	if {![matchattr $hand o] && ![info exists usr(remort)] && [set user [nick2hand $nick]] != $game(creator) && !([lsearch -exact [channel info $chan] "+bitch"] == -1 && [users isintop $user]) && $nick != $botnick} { return deny }
	set msg " ."
	if {$game(qid)} {
		append msg " [lindex {. { } { } { }} [numgrp $game(qid)]] $game(qid) [lindex {.   } [numgrp $game(qid)]]"
		if {$game(cnt_won)} { append msg ",    $game(cnt_won)    ." } else { append msg "." }
		append msg "   [game_time]."
	}
	putfast "privmsg $chan :\00304$msg\003"
if {$conf(modset) eq 1} {putfast "MODE $chan +c"}

		if {[expr ([clock seconds] - $game(started))] > [getuser $conf(owner) XTRA TIMEREC]} {
	setuser $conf(owner) XTRA TIMEREC [expr ([clock seconds] - $game(started))]
	setuser $conf(owner) XTRA QUESTCOUNT $game(qid)
	
}	
    if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	unset game
	variable g; unset g
	users purge
}
###   
proc ::tpub::cmd_ {nick chan text} { return [cmd_top $nick $chan $text] }
proc ::tpub::cmd_njg {nick chan text} { return [cmd_top $nick $chan $text] }
proc ::tpub::cmd_top {nick chan text} { variable game; variable conf
	if {"$chan $text" == "? ?"} { return [usage $nick top "??" "    ."] }

	
	
	if {$text == ""} {
	if {![llength [set users [users list]]]} {
		putmsg $chan "$nick,   ."
		return 0
	}
	
		set msg ""
		set place 0
		foreach item [lrange [users list] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
			unset item
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310    :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"} }
	 
	 if {[llength [set users [users listmonth]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users listmonth] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310   :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } 
		}
		if {[llength [set users [users listday]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users listday] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310    ([clock format [clock seconds] -format "%d.%m.%Y"]):\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "    \:\("}
		return
		}
		
		
	}
	#putlog "$text"
 

if {$text != ""} {
regsub -all {[\<\>]} $text "" text
## 
if {[string match "*" $text] || [string match "hel*" $text]} { putserv "NOTICE $nick : ! <>.  : , , , , , , ."; return }
	
	
	
	##  
	if {[string match "*" $text] || [string match "spee*" $text]} {
	 if {[llength [set users [users list3]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list3] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310  :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "  ."}
		return
		}
	}
	#  
	if {[string match "*" $text] || [string match "mon*" $text]} {
	 if {[llength [set users [users listmonth]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users listmonth] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310   :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "    ."}
		return
		}
	}
	
	#  
	if {[string match "*" $text] || [string match "*" $text] || [string match "*" $text] || [string match "day*" $text]} {
	 if {[llength [set users [users listday]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users listday] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310   [clock format [clock seconds] -format "%d.%m.%Y"]:\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "    \:\("}
		return
		}
		}
	#  
	if {[string match "*" $text] || [string match "super*" $text]} {
	 if {[llength [set users [users list4]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list4] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310     :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "     ."}
		return
		}
	}
	
	#  
	if {[string match "*" $text] || [string match "anag*" $text]} {
	 if {[llength [set users [users list5]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list5] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310     -:\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "    - ."}
		return
		}
	}
	#  
	if {[string match "*" $text] || [string match "auk*" $text]} {
	 if {[llength [set users [users list6]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list6] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310     :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "     ."}
		return
		}
	}
	#####
	#  10 - 100
	if {[string match "10" $text] || [string match "20" $text] || [string match "30" $text] || [string match "40" $text] || [string match "50" $text] || [string match "60" $text] || [string match "70" $text] || [string match "80" $text] || [string match "90" $text] || [string match "100" $text]} {
	set msg ""
	set tpo [regsub -all -- {[--a-zA-z]} $text ""]
		set place [expr $tpo -10]
		foreach item [lrange [users list] [expr $tpo -10] [expr $tpo -1]] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
			unset item
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310$tpo    :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putserv "PRIVMSG $chan :    ."}
	return
	}
	#   10 - 100
	if {[string match "*10" $text] || [string match "*20" $text] || [string match "*30" $text] || [string match "*40" $text] || [string match "*50" $text] || [string match "*60" $text] || [string match "*70" $text] || [string match "*80" $text] || [string match "*90" $text] || [string match "*100" $text]} {
	set msg ""
	set tpo [regsub -all -- {[--a-zA-z]} $text ""]
		set place [expr $tpo -10]
		foreach item [lrange [users list1] [expr $tpo -10] [expr $tpo -1]] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
			unset item
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310$tpo   :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putserv "PRIVMSG $chan :    ."}
	return
	}
	
	#  
	if {[string match "*" $text] || [string match "ans*" $text]} {
	 if {[llength [set users [users list1]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list1] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310   :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "  ."}
		return
		}
	}
	
	##  
	if {[string match "*" $text]} {
	 if {[llength [set users [users list2]]]} {
		set msg ""
		set place 0
		foreach item [lrange [users list2] 0 9] {
			if {[lindex $item 1] != 0} { append msg ", \00304\002\002[incr place]. \00303[lindex $item 0]\00314 (\00307[lindex $item 1]\00314)\00310" }
		}
		if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putmsg $chan "\00310    :\00304 [string range $msg 2 end]\00310.\003"; if {$conf(modset) eq 1} {putserv "MODE $chan +c"}  } {putmsg $chan "  ."}
		return
		}
	}
	###
	}

}



###    
proc ::tpub::msgwon {nick uhost hand args} {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	won $nick $uhost $hand $nick $args
}
proc ::tpub::pubwon {nick uhost hand chan args} {
	variable conf
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	###if {[lindex $conf(channels) 0]!=$chan }  return
	if {[lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] == -1 || $hand == "*"} { return }
	won $nick $uhost $hand $chan $args
}
proc ::tpub::won {nick uhost hand chan text} {
variable game
variable conf
		if {[string first "f" [chattr [nick2hand $nick] [expr {[validchan $chan] ? $chan : ""}]]] == -1 && [info exists game]} {
		if {[info exists game(wonsent)] && [lsearch $game(wonsent) $nick] != -1} {
			return
		}
		lappend game(wonsent) $nick
	}
	set msg_n ""
	if {$text == ""} {
		set hand [nick2hand $nick]
	} elseif {![validuser [set hand [lindex [split $text] 0]]]} {
		set hand [nick2hand $hand]
	}
	if {[string is int $text] && $text != ""} {
		set list [users list]
		if {[expr int($text)] > [llength $list]} {
			putfast "notice $nick :    [llength $list] [lindex {.   } [numgrp [llength $list]]]."
			return 0
		}
		set hand [lindex [lindex $list [expr int($text) - 1]] 0]
	}
	if {$hand == "" || $hand == "*"} {
		if {$text == ""} {
			putfast "notice $nick :    ,  ? :)"
		} else {
			putfast "notice $nick : $text  ..."
		}
		return 0
	}
	set hand [users check [list $hand $nick]]
	array set user [set xtra [users get $hand]]
	set place [place $hand]	
	set place1 [place1 $hand]
	set place2 [place2 $hand]
	if {$xtra == ""} {
		putfast "notice $nick :    $hand   ."
		return 0
	}
	set ko 0
	set honor ""
		foreach item $conf(drank) { 
		if {$user(score)<=$item} { set honor [lindex $conf(rank) $ko]; break}
		incr ko } 
	if {$honor==""} {set honor $conf(dmax)}
	set msg "\00310  \00304[expr {[info exists user(remort)] ? "\002$hand\002" : $hand}]\00310(\0035[expr {[info exists user(tremort)] ? $user(tremort) : $honor}]\00310)  \00307\002\002$user(answers)\002\002\00310 [lindex {.   } [numgrp $user(answers)]] (\00303\002\002$user(score)\002\002 [lindex {.   } [numgrp $user(score)]]\00310)"
	if {$user(answersmonth) > 0} { append msg "    \00307$user(answersmonth)\00310 [lindex {.   } [numgrp $user(answersmonth)]] (\00303$user(scoremonth) [lindex {.   } [numgrp $user(scoremonth)]]\00310)   " }
	if {$user(answersday) > 0} { append msg "  \00307$user(answersday)\00310 [lindex {.   } [numgrp $user(answersday)]] (\00303$user(scoreday) [lindex {.   } [numgrp $user(scoreday)]]\00310)  " }
	
	if {$user(cont) > 1} {
		append msg ",   - \00307\002\002$user(cont)\002\002\00310 [lindex {.   } [numgrp $user(cont)]] "
	}
	append msg ",       \00307\002\002$user(quick)\002\002\00310 [lindex {.   } [numgrp $user(quick)]]"
	if {[info exists user(supergames)] && $user(supergames) > 0} {
		append msg ",    \00307$user(supergames)\00310 [lindex {.   } [numgrp $user(supergames)]]"
	}
	if {[info exists user(augames)] && $user(augames) > 0} {
		append msg ", [lindex {.    } [numgrp $user(augames)]] \00307$user(augames)\00310 [lindex {.    } [numgrp $user(augames)]]"
	}
	
	if {[info exists user(anwins)] && $user(anwins) > 0} {
		append msg ",  [lindex {.    } [numgrp $user(anwins)]] \00307$user(anwins)\00310 [lindex {.   } [numgrp $user(anwins)]]"
	}
	
	if {[info exists user(memo)]} {
		append msg " (\00307: \00304$user(memo)\00310)"
	}
	
	if {$user(score)!=0 || $user(answers) != 0} {
	set sball [expr 1.0 * $user(score) / $user(answers)]
	if {[regexp -nocase -- {^(\d+)\.(\d{1,3})} $sball a sbal b] } { 
	set sbal "$sbal.$b" 
	append msg ".   - \00307$sbal\00310"
		}
	}
	
	if {$place} {
		set honor [expr {$place < 6 ? " " : ""}]
		append msg_n "\00310$honor \00307\002\002$place-\002\002\00310 "
	} 
	
	if {$place1} {append msg_n ",    \00307\002\002$place1-\002\002\00310    "	} 
	if {$place2} {append msg_n "  \00307\002\002$place2-\002\002\00310   "	}
	
	if {$user(answers) != 0} {
	if {[string trim [getuser $hand XTRA ATIME]] != ""} {
		append msg ",     \00307\002\002[::tpub::duration [expr [getuser $hand XTRA ATIME] / $user(answers)] 1]\002\002\00310"
	}
     }
	 
set quizutime "[ctime [getuser $hand XTRA created]]" 
set mesyats "mesyats" 
if {[string match "*Jan*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Feb*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Mar*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Apr*" "$quizutime"]} { set mesyats "" } 
if {[string match "*May*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Jun*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Jul*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Aug*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Sep*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Oct*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Nov*" "$quizutime"]} { set mesyats "" } 
if {[string match "*Dec*" "$quizutime"]} { set mesyats "" } 
set god [lindex $quizutime 4] 
set time [lindex $quizutime 3] 
set chislo [lindex $quizutime 2] 
set newtime "$chislo $mesyats $god  ($time)" 
	 if {$user(score) != 0} {
	if {[string trim [getuser $hand XTRA created]] != ""} {
		append msg_n ". \00310  - \00307\002\002$newtime\00310"
	}
     }
###########################################################################
	 set quizutimelast "[ctime $user(last)]" 
set mesyats "mesyats" 
if {[string match "*Jan*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Feb*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Mar*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Apr*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*May*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Jun*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Jul*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Aug*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Sep*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Oct*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Nov*" "$quizutimelast"]} { set mesyats "" } 
if {[string match "*Dec*" "$quizutimelast"]} { set mesyats "" } 
set god [lindex $quizutimelast 4] 
set time [lindex $quizutimelast 3] 
set chislo [lindex $quizutimelast 2] 
set newtimelast "$chislo $mesyats $god  ($time)" 
	 if {$user(score) != 0} {
			append msg_n ".   () - \00307\002\002$newtimelast\00310"
     }
###############################################################################
	 if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; 
	
	if {[string length $msg] > 390} {
set clr [lindex [split [string range $msg 0 390] "\x03"] end]
regexp -- {(\d+)} $clr -> clr
putfast "privmsg $chan :\00310[string range $msg 0 390]"
putfast "privmsg $chan :\003$clr[string range $msg 391 end]\00310.\003"
} else {putfast "privmsg $chan :\00310$msg.\003"}
	
	
	if {[info exists msg_n]} { 
	
	if {[string length $msg_n] > 390} {
set clr [lindex [split [string range $msg_n 0 390] "\x03"] end]
regexp -- {(\d+)} $clr -> clr
putfast "privmsg $chan :\00310[string range $msg_n 0 390]"
putfast "privmsg $chan :\003$clr[string range $msg_n 391 end]\00310.\003"
} else {putfast "privmsg $chan :\00310$msg_n.\003"}
	
	if {$conf(modset) eq 1} {putfast "MODE $chan +c"};  }
	if {[info exist user(remort)] && $user(remort) > 0} {
		set msgs "\00310$hand     \00307$user(remort)\00310 "
	if {[string trim [getuser $hand XTRA TIME]] != ""} {
		if { [getuser $hand XTRA TMPTIME] != "" } {
set atime [expr [clock seconds] - [getuser $hand XTRA TMPTIME]]
set gtime [expr [getuser $hand XTRA TIME] + $atime]
append msgs "     \00307\002\002[::tpub::duration $gtime 0]\002\002\00310"
}
	}
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; 
	putfast "privmsg $chan :$msgs.\003"
	if {$conf(modset) eq 1} {putfast "MODE $chan +c"}; 
		}	
}


proc ::tpub::cmd_ {nick chan text} { return [cmd_records $nick $chan $text] }
proc ::tpub::cmd_htrjhls {nick chan text} { return [cmd_records $nick $chan $text] }
proc ::tpub::cmd_htrjhl {nick chan text} { return [cmd_records $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_records $nick $chan $text] }
proc ::tpub::cmd_record {nick chan text} { return [cmd_records $nick $chan $text] }
proc ::tpub::cmd_records {nick chan text} { variable game
variable conf
if {$text == "?help?"} { return [usage $nick $chan records "" "  ."] }
set msg ""
set statrec [lindex [users list] 0]
if {$statrec != ""} {
	set msg "\00310 :"  
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310     \00303$handr\00310 - \00307\002\002$handrval\002\002"
}
set statrec [lindex [users list1] 0]
if {$statrec != ""} { 
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310,      \00303$handr\00310 - \00307\002\002$handrval\002\002"
}
unset statrec
set statrec [lindex [users list2] 0]
if {$statrec != ""} { 
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310,      \00303$handr\00310 - \00307\002\002$handrval\002\002"
}
unset statrec
set statrec [lindex [users list4] 0]
if {$statrec != ""} { 
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310,     -  \00303$handr\00310 - \00307\002\002$handrval\002\002\00310"
}
unset statrec
set statrec [lindex [users list5] 0]
if {$statrec != ""} { 
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310,     \00303$handr\00310 - \00307\002\002$handrval\002\002\00310"
}
unset statrec
set statrec [lindex [users list3] 0]
if {$statrec != ""} { 
	set handr [lindex $statrec 0]
	set handrval [lindex $statrec end]
	append msg "\00310,      \00303$handr\00310  \00307\002\002$handrval\002\002\00310 "
}
unset statrec
#
if {[getuser $conf(owner) XTRA TIMEREC] ne ""} {append msg "\00310.    \00307[::tpub::duration [getuser $conf(owner) XTRA TIMEREC]]\00310"}
if {[getuser $conf(owner) XTRA QUESTCOUNT] ne ""} {set questcount [getuser $conf(owner) XTRA QUESTCOUNT];append msg ",    () \00307$questcount\00310 [lindex {.   } [numgrp $questcount]]\00310"}
if {$msg != ""} { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; 
if {[string length $msg] > 390} {
set clr [lindex [split [string range $msg 0 390] "\x03"] end]
regexp -- {(\d+)} $clr -> clr
putfast "privmsg $chan :\00310[string range $msg 0 390]"
putfast "privmsg $chan :\003$clr[string range $msg 391 end]\00310.\003"
} else {putfast "privmsg $chan :\00310$msg.\003"}

if {$conf(modset) eq 1} {putfast "MODE $chan +c"};  } else { if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; putfast "privmsg $chan :\00310  .\003"; if {$conf(modset) eq 1} {putfast "MODE $chan +c"} }
}
proc ::tpub::cmd_ {nick chan text} { return [cmd_place $nick $chan $text] }
proc ::tpub::cmd_vtcnj {nick chan text} { return [cmd_place $nick $chan $text] }
proc ::tpub::cmd_place {nick chan text} { variable game
variable conf
if {$text == "?help?"} { return [usage $nick $chan place "??" "     ,       ,         ."] }
#putlog "::Quiz:: place: text=$text :: nick=$nick"

if {![isnumber [lindex $text 0]]} {
if {$text == ""} {
		if {[validuser [nick2hand $nick]]} {
		set hand [nick2hand $nick] } else { set hand $nick }
	} else {
		set hand [lindex $text 0]
	}
	#putlog "::Quiz:: place1: text=$text :: nick=$nick :: hand=$hand ::n2h=[nick2hand $nick]"
  } else {  if {[lindex $text 0] > [llength [users list]]} {
		putfast "notice $nick :  ,   ;)"
		return 0 
     	      }
		set hand [lindex [place [lindex $text 0]] 0]
	   }
		if {[regexp -nocase -- {^\-\d+$} [lindex $text 0]]} {
			regsub -all -- {\-} $hand {} hand
	     	      if {$hand > [llength [users list]]} {
				putfast "notice $nick :  ,   ;)"
				return 0 
			 }
		}
			#putlog "::Quiz:: place2: text=$text :: nick=$nick :: hand=$hand"
putlog "3"
		if {[place $hand]<=0} {
			#putlog "::Quiz:: place3: text=$text :: nick=$nick :: hand=$hand"
putlog "4"
			if {$text == ""} {
				putfast "notice $nick :      ,   ? ;)"
			} else {
				putfast "notice $nick :  $text  ..."
			}
			return 0
		}
	array set user [set xtra [users get $hand]]
	set place [place $hand]	
	set place1 [place1 $hand]
	set place2 [place2 $hand]
	
	set clist [users list]
	set clist1 [users listmonth]
	set clist2 [users listday]
	
	set trace [lindex [lindex $clist [expr $place -2]] 1]
	set trace1 [lindex [lindex $clist1 [expr $place1 -2]] 1]
	set trace2 [lindex [lindex $clist2 [expr $place2 -2]] 1]
	set raz [expr $trace - $user(score)]
	set raz1 [expr $trace1 - $user(scoremonth)]
	set raz2 [expr $trace2 - $user(scoreday)]
	
	set ko 0
	foreach item $conf(drank) { 
		if {$user(score)<=$item} { set honor [lindex $conf(rank) $ko]; break}
			incr ko
		} 
	if {![info exists honor]} {set honor $conf(dmax)}
	set honorfive [expr {$place < 6 ? " " : ""}]
	set msgs "\00304[expr {[info exists user(remort)] ? "\002$hand\002" : $hand}]\00305([expr {[info exists user(tremort)] ? $user(tremort) : $honor}]\00305)\00310 $honorfive \00307\002\002$place\002\002\00307-\00310(\00303\002\002$user(score) [lindex {.   } [numgrp $user(score)]]\002\002\00310)    "
	if {$place > 1} { append msgs "  \00303\002\002[expr {$raz == 0 ? " " : "$raz \00310\002\002[lindex {.   } [numgrp $raz]]" }]\002\002\00310   " } 
	
	if {$user(scoremonth) != 0} { append msgs ",    \00307$place1-\00310(\00303$user(scoremonth) [lindex {.   } [numgrp $user(scoremonth)]]\00310)    "
	if {$place1 > 1} { append msgs "  \00303[expr {$raz1 == 0 ? " " : "$raz1 [lindex {.   } [numgrp $raz1]]" }]\00310  "}
	}
	
	if {$user(scoreday) != 0} { append msgs ",   \00307$place2-\00310(\00303$user(scoreday) [lindex {.   } [numgrp $user(scoreday)]]\00310)   "
	if {$place2 > 1} { append msgs "  \00303[expr {$raz2 == 0 ? " " : "$raz2 [lindex {.   } [numgrp $raz2]]" }]\00310  "}
	}
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; 
	putfast "privmsg $chan :$msgs."
	if {$conf(modset) eq 1} {putfast "MODE $chan +c"}; 
	#putfast "privmsg $chan :\00304[expr {[info exists user(remort)] ? "\002$hand\002" : $hand}]\00305([expr {[info exists user(tremort)] ? $user(tremort) : $honor}]\00305)\00310 $honorfive \00304$place\00307-\00304(\00303$user(score) [lindex {.   } [numgrp $user(score)]]\00304)\00310   \00304[expr {$place <= 1 ? "" : [expr {$raz == 0 ? " " : "$raz \00310[lindex {.   } [numgrp $raz]]"}] }]\00310   ."
}
proc ::tpub::cmd_ {nick chan text} { variable game
variable conf
if {![isnumber [lindex $text 0]]} {
if {$text == ""} {
		if {[validuser [nick2hand $nick]]} {
		set hand [nick2hand $nick] } else { set hand $nick }
		} 
	array set user [set xtra [users get $hand]]
	set place [place $hand]
	if {[place $hand] ==1} { putfast "notice $nick :\00310 \(: ..."; return 0 }
		set clist [users list]
	set trace [lindex [lindex $clist [expr $place -2]] 1]
	set raz [expr $trace - $user(score)]
	set raznick [lindex [lindex $clist [expr $place -2]] 0]
	} 
	putfast "notice $nick :\00310   \00304\002\002$raz\00310 [lindex {.   } [numgrp $raz]] \(\00304 $raznick\00310\)"
}


proc ::tpub::cmd_ {nick chan text} { return [cmd_reg $nick $chan $text] }
proc ::tpub::cmd_reg {nick chan text} {
variable conf; variable game; global regusers
	if {$text == "?help?"} { return [usage $nick $chan  "" "    ,      "] }
	if {![info exists conf(mpeople)] || [lindex $conf(channels) 0] != $chan} { return 0 }
	if {[info exists game]} {
		if {[lsearch -exact $game(ausers) $nick] >= 0} {putnot $nick "    ."; return 0}
		lappend game(ausers) $nick
		timer $conf(tcheck) [list tpub::checkusr $nick]
		putmsg $chan "\00304$nick,      .\003"
	} else {
		if {![info exists regusers]} {set regusers ""}
		if {[lsearch -exact $regusers $nick] >= 0} {putnot $nick "    ."; return 0}
		lappend regusers $nick
		putmsg $chan "\00304$nick,      .  [lindex {.   } [numgrp [llength $regusers]]] \00304[llength $regusers] [lindex {.   } [numgrp [llength $regusers]]].\003"
		if {[llength $regusers]>=$conf(mpeople) && ![info exists game]} {
			putmsg $chan "\00304,  ,  !\003"
			cmd_start $nick $chan $text
			variable game
			foreach user $regusers {
				timer $conf(tcheck) [list tpub::checkusr $user]
				lappend game(ausers) $user
			}
			unset regusers
		}
	}
}
proc ::tpub::cmd_ {nick chan text} { return [cmd_unreg $nick $chan $text] }
proc ::tpub::cmd_unreg {nick chan text} {
	variable conf; variable game; global botnick regusers
	if {$text == "?help?"} { return [usage $nick $chan  "" "    ,       "] }
	if {![info exists conf(mpeople)]} {return}
	if {[info exists game]} {
		if {[set k [lsearch -exact $game(ausers) $nick]] == -1} {putnot $nick "     ."; return}
		set game(ausers) [lreplace $game(ausers) $k $k]
		putmsg $chan "\00304$nick,       .\003"
		if {[info exists game] && (![llength $game(ausers)] || [llength $game(ausers)] < $conf(mpeople))} {
			putmsg [lindex $conf(channels) 0] "\00304    . :(\003"; cmd_stop $botnick [lindex $conf(channels) 0] ""
			return
		}
	} else {
		if {![info exists regusers] || [set k [lsearch -exact $regusers $nick]] == -1} {putnot $nick "     ."; return}
		set regusers [lreplace $regusers $k $k]
		putmsg $chan "\00304$nick,       .\003"
	}
}

if {[info exists ::tpub::conf(mpeople)]} {
   bind nick - * ::tpub::tchgnick
} else { catch {unbind nick - * ::tpub::tchgnick}}

bind nick - * ::tpub::tchgnick
proc ::tpub::tchgnick {nick uhost hand chan newnick} {
	variable game
	if {![info exists game]} {return}
	if {[set k [lsearch -exact $nick $game(ausers)]] != -1} {
		set game(ausers) [lreplace $game(ausers) $k $k $newnick]
	}
}

proc ::tpub::checkusr {nick} { variable conf; global botnick; variable game
	if {![info exists game] || ![info exists conf(mpeople)] || [set k [lsearch -exact $game(ausers) $nick]] == -1} {return}
	foreach timer [timers] {
		if {[string match [lindex $timer 1] "tpub::checkusr $nick"]} {return}
	}
	# ,     ...
	if {![onchan $nick $game(chan)]} {
		set game(ausers) [lreplace $game(ausers) $k $k]
		putmsg $game(chan) "\00304$nick         ."
	#      ?
	} elseif {[getchanidle $nick $game(chan)] > $conf(tidle)} {
		set game(ausers) [lreplace $game(ausers) $k $k]
		putmsg $game(chan) "\00304$nick       ."
	}
	# ,   
	if {[llength $game(ausers)] < $conf(mpeople)} {
		putmsg $game(chan) "\00304   .\003"; cmd_stop $botnick $game(chan) ""
		return
	}
	#   
	timer $conf(tcheck) [list tpub::checkusr $nick]
}
proc ::tpub::checkusrsilent {nick} { variable conf; variable game
	if {![info exists game] || [set k [lsearch -exact $game(ausers) $nick]] == -1} {return}
	foreach timer [timers] {
		if {[string match [lindex $timer 1] "tpub::checkusrsilent $nick"]} {return}
	}
	# ,     ...
	if {![onchan $nick $game(chan)]} {
		set game(ausers) [lreplace $game(ausers) $k $k]
	#      ?
	} elseif {[getchanidle $nick $game(chan)] > 5} {
		set game(ausers) [lreplace $game(ausers) $k $k]
	}
	timer $conf(tcheck) [list tpub::checkusrsilent $nick]
}



###   
proc ::tpub::cmd_ {nick chan text} { return [cmd_stat $nick $chan $text] }
proc ::tpub::cmd_c {nick chan text} { return [cmd_stat $nick $chan $text] }
proc ::tpub::cmd_stat {nick chan text} { variable game; variable conf
	if {$text == "?help?"} { return [usage $nick $chan stat "" "    ,     ."] }
	set usercount [llength [users list]]
	set msg "    [set ::tpub::qcount] [lindex {.   } [numgrp [set ::tpub::qcount]]],   [set count [question count]]   [lindex {.   } [numgrp $count]].  [lindex {.   } [numgrp $usercount]] $usercount [lindex {.   } [numgrp $usercount]]"
#####    [set ::tpub::qcount] [lindex {.   } [numgrp [set ::tpub::qcount]]]    [lindex {. { } { } { }} [numgrp $game(qid)]] $game(qid) [lindex {.   } [numgrp $game(qid)]]    $game(cnt_won)    .
	if {[info exists game]} {
		if {$chan != $game(chan)} {
			append msg ".        $game(chan)"
		}
		append msg ".    [lindex {. { } { } { }} [numgrp $game(qid)]] $game(qid) [lindex {.   } [numgrp $game(qid)]]    $game(cnt_won)    .    [game_time]"
		if {[info exists game(creator)]} {
			append msg ",      $game(creator)"
		}
	}
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}; 
	putfast "privmsg $chan :\00304$msg.\003"
	if {$conf(modset) eq 1} {putfast "MODE $chan +c"}; 
}










###   
proc ::tpub::tmr_ask {} { 
	variable game
	variable conf
	variable qpos
	global tempqid anagrqid qidanswer anagrgame augamecount isau au_ch sch
	if {[info exists game(question)]} { unset game(question) }
	if {![info exists game] || [info exists game(question)]} { return }
	#   
	killtm
    if {[info exists game(alreadyhint)]} { unset game(alreadyhint) }
	if {[info exists isau] && $isau == 1} { set isau 0 }
	
	set qidanswer "123"
	set game(hint1d) 0
	set game(question) [question get]
	set game(points) 3
	set game(asktime) "[clock seconds].[string range [clock clicks -milliseconds] [expr [string length [clock clicks -milliseconds]] - 3] end]"
	incr game(qid)
	incr tempqid
	incr anagrqid
	incr augamecount
	#putlog "$augamecount"
	#putlog "\00307 -  $conf(tempqid) ,  $tempqid ."
		if {$tempqid == $conf(tempqid)} {
	 set qidanswer [rand 100]
	 set chislo [expr [rand 499] +1]
	 if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}; 
 	 putserv "privmsg $game(chan) :\00314   \00304 0\00314 \00304 100\00314. .  -\00303 $chislo\00314 [lindex {.   } [numgrp $chislo]] :)\003"
	 putlog "  - - $qidanswer"
	 if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	 set tempqid 0
	 set game(points) $chislo
	 utimer $conf(anstime) [list ::tpub::tmr_next $game(qid)]
	} else {
	
	
	if {$anagrqid == $conf(anagrqid)} {
	variable game

	set anagrgame(slovo) [tolower [lindex $conf(an_base) [rand [llength $conf(an_base)]]]]
	set anagrgame(slovo2) $anagrgame(slovo)
	set anagrgame(dlina) [string length $anagrgame(slovo)]
	set i 0
	while {$i != $anagrgame(dlina)} {
	if {[info exists wMap([string index $anagrgame(slovo) $i])]} {
	incr wMap([string index $anagrgame(slovo) $i])
	} else {
	array set wMap [list [string index $anagrgame(slovo) $i] {1}]
	}
      incr i
      }
	set anagrgame(rslovo) ""
	set anagrgame(abr) ""
	set j 0
	expr srand(666)
	while {$j!=$anagrgame(dlina)} {
    set anagrgame(rslovo) [string index $anagrgame(slovo) [rand $anagrgame(dlina)]]
	if {[info exists wMf([string index $anagrgame(rslovo) 0])]} {
    incr wMf([string index $anagrgame(rslovo) 0])
	} else {
	array set wMf [list [string index $anagrgame(rslovo) 0] {0}]
	}
	if {$wMf([string index $anagrgame(rslovo) 0])<$wMap([string index $anagrgame(rslovo) 0])} {
		append anagrgame(abr) $anagrgame(rslovo)
		incr j
		}
	}
	if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}; 
	putfast "privmsg $game(chan) :\00304! -!"
	putfast "privmsg $game(chan) :\00302   : \00312$anagrgame(abr) ?\003"
	putlog "   - $anagrgame(slovo)"
	set anagrqid 0
	set game(points) $anagrgame(dlina)
	set anagrgame(dl) $anagrgame(dlina)
	if {[info exists conf(thint)]} { utimer $conf(thint) [list ::tpub::htime $game(qid)] }
	utimer $conf(anstime)  [list ::tpub::tmr_next $game(qid)]
	} else {
if {$augamecount == $conf(a_questions)} {
if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}; 
putmsg $game(chan) "\00304!  -!\003"
putmsg $game(chan) "\00310      ?   !   - \00304! <>\00310 .\00310   10 !"
	 if {[info exists sch] && $sch >0} {set sch 0}
	 set isau 1
	 set augamecount 0
	 
	 
	
	set au_ch 1
	utimer 10 [list ::tpub::tmr_next $game(qid)]
	} else {	
 
	##    
	if {([string match *\{* [lindex $game(question) 1]])} {
	    #     1
	    set lln [string length [lindex $game(question) 1]]
	    set lln [incr lln -4]
	    set ln "$lln [lindex {.   } [numgrp $lln]] \00304( )\00307"
	} else {
	    #    1
	    set ln "[string length [lindex $game(question) 1]] [lindex {.   } [numgrp [string length [lindex $game(question) 1]]]]\00307"
	}
if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	
if {[rand $conf(rand)]==22 || [info exists game(dex)] && $game(dex) > 0 } { 
if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
	putmsg $game(chan) "\00307- (#$game(qid)):\00312 [anticheat [lindex $game(question) 0]] \00307\($ln\)\003"
	set game(extra) 1 
	} else {
#incr game(qid)
if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
putmsg $game(chan) "\00302Bonpoc #$game(qid): \00312[anticheat [lindex $game(question) 0]] \00307\($ln\)\003"
####putmsg $game(chan) "bla - $game(question)"
}
#####	utimer $conf(anstime) [list ::tpub::tmr_next $game(qid)]
	utimer $conf(anstime) [list ::tpub::tmr_next $game(qid)]
	if {[info exists conf(thint)]} { utimer $conf(thint) [list ::tpub::htime $game(qid)] }
	unset ln
	
	}
}
}
}


	
proc ::tpub::au_run { nick chan args } {	
global au_nick isau auisa auisanick austavka auhand sch
	variable game
	variable conf
	
	
if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
putfast "PRIVMSG $game(chan) :\00310 !    !"
	
	 
	
	 
	 set winners {}
	 foreach lines $::tpub::auusers {
	 
	 set stavka_ [lindex [split $lines " "] 0]
	 set st_nick [lindex [split $lines " "] 1]
	 
	 if {[info exists lines]} {
	 lappend winners [list $lines $stavka_]
	 putlog "stavka_ - $stavka_ && st_nick - $st_nick"
	 putlog "winners_list=$winners"
	 }
	 }

			# sort 
			set sorted {}
			foreach item [lsort -decreasing -index 1 $winners] {
				lappend sorted [lrange $item 0 1]
			}
			set winnerrr_points [lindex [split $sorted " "] 0]
			set winnerrr_user [lindex [split $sorted " "] 1]
			regsub -all -- {\{} $winnerrr_points "" winnerrr_points
			regsub -all -- {\}} $winnerrr_user "" winnerrr_user

	 putlog "winnerrr - $winnerrr_user"
	 set win_nick $winnerrr_user
	 

		#	putlog "winner - $win_nick"

			set sn {}
			
			foreach au_user [lindex [chanlist $chan]] {
			if {$au_user != $win_nick && $au_user != $::botnick} {
			lappend sn $au_user
			}
			set a1 0
			set a2 ""
			while {$a1 < [llength $sn]} {
			append a2 "v"
			incr a1
			}
			}
		 putserv "mode $chan +m-$a2 [join [lrange $sn 0 9]]"
		# putlog "a2 -- $a2 ; a1 -- $a1 ---- mode $chan +m-$a2 [join [lrange $sn 0 9]]"
		 if {[expr [string length $a2] >10]} {	 putserv "mode $chan -$a2 [join [lrange $sn 10 19]]"}
		 set a2 ""
	 


after 5000
set game(points) [lindex $winnerrr_points 0]
	#putfast "privmsg $chan :DEBUG : $args : $game(points)"
	killtm	
	set au_nick "000"
	set isau 0
	set game(hint1d) 0
	set game(question) [question get]
	set game(asktime) [clock seconds]
if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
	putfast "privmsg $chan :\00304, -\00310 \00303 $win_nick\00310! :\00304 $game(points)\00310 [lindex {.   } [numgrp $game(points)]].\003"
	putmsg $chan "\00304-\00312(#$game(qid)): [anticheat [lindex $game(question) 0]]\00312.\003"
	putfast "privmsg $chan :\00310 \00303$win_nick\00310!    \00304$conf(anstime)\00310 ."
	set auisa 1
	set auisanick "$win_nick"
	set auhand [nick2hand $auisanick]
	set austavka $game(points)
	putlog "$auisa $auisanick"
	utimer $conf(anstime) [list ::tpub::tmr_next $game(qid)]
	
	
	 
	 return
}



proc ::tpub::htime {qid} {
	variable game
	if {![info exists game(alreadyhint)]} { ::tpub::tmr_hint $qid }
}
###   
proc ::tpub::on_join {nick uhost handle chan} { 
	variable game
	variable conf
	global lock
	
	#putfast "PRIVMSG $chan :::Quiz::DEBUG: isa=$::isa :: auisa=$::auisa :: qidanswer=$::qidanswer"
	if {[info exists anagrgame(slovo)]} {putfast "PRIVMSG $chan :::Quiz::DEBUG::: anslovo=$anagrgame(slovo)"}
	if {[info exists lock] && $lock eq 1} {return}
	
	if {[info exists game(question)]} {
	    #    1
	    set ln "[string length [lindex $game(question) 1]] [lindex {.   } [numgrp [string length [lindex $game(question) 1]]]]"
	}
	##     
	if {[lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] != -1 && $handle == "*"} { 
		set not "\00310, \00309$nick\00310\.      \"\"!"
  	
	
	if {[info exists game]} {
		append not "    [game_time]"
		if {[info exists game(question)] && [info exists game(ausers)] && $game(ausers) >0} {
			append not ",   [llength [split $game(ausers) " "]] [lindex {.   } [numgrp [llength [split $game(ausers) " "]]]]"
		}
		
			if {[info exists game(question)] && [lsearch -exact $game(question) "3333"]<0 && ![info exists anagrgame(slovo)] && $::isa !=1 && $::auisa !=1 && $::qidanswer == 123 && $::isau !=1} {
			append not ". : \"[lindex $game(question) 0] \($ln\)\""
		}
		if {[info exists ::isau] && $::isau == 1} {
		append not ".     !       ! <>" 
		}
		if {[info exists anagrgame(slovo)]} {
		append not ". -: \"[lindex $anagrgame(slovo)]\""
		}
		if {[info exists ::qidanswer] && $::qidanswer != 123} {
		append not ". :    0  100 \;\)"
		}
		if {[info exists ::isa] && $::isa == 1 && $nick != $::isanick} {
		append not ".  ! : $::isanick, : $game(points)"
		}
		if {[info exists ::auisa] && $::auisa == 1 && $nick != $::auisanick} {
		append not ". -! : $::auisanick, : $game(points)"
		}
			if {$chan != $game(chan)} {
			append not "\00310.       \002\00312 $game(chan)\017."}
	} else { append not "    .  \002!\002  .\017" }
		putfast "notice $nick :$not"	
		return }
		
	if {[lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] == -1 || $handle == "*"} { return }
	##     .    
	array set usr [users get $handle]
	if {[users isintop $handle]} {
		if {$usr(score) > 100} { putquick "MODE $chan +v $nick" }
	}
	if {[users isremort $handle]} {
		putquick "MODE $chan +v $nick"
	}
    
	if {[users isintop $handle]} {
		if {[place $handle] == 1} { putquick "MODE $chan +aoh $nick $nick $nick" }
		if {[place $handle] == 2} { putquick "MODE $chan +oh $nick $nick" }
		if {[place $handle] == 3} { putquick "MODE $chan +h $nick" }
	}
	
	set not "\00310, \00308$nick\00310\.      \"\"!"
	if {[info exists game]} {
		append not "    [game_time]"
		
		if {[info exists game(question)] && [info exists game(ausers)] && $game(ausers) >0} {
			append not ",   [llength [split $game(ausers) " "]] [lindex {.   } [numgrp [llength [split $game(ausers) " "]]]]"
		}
		
		if {[info exists game(question)] && [lsearch -exact $game(question) "3333"]<0 && ![info exists anagrgame(slovo)] && $::isa !=1 && $::auisa !=1 && $::qidanswer == 123 && $::isau !=1} {
			append not ". : \"[lindex $game(question) 0] \($ln\)\""
		}
		if {[info exists ::isau] && $::isau == 1} {
		append not ".     !       ! <>" 
		}
		
		if {[info exists anagrgame(slovo)]} {
		append not ". -: \"[lindex $anagrgame(slovo)]\""
		}
		if {[info exists ::qidanswer] && $::qidanswer != 123} {
		append not ". :    0  100 \;\)"
		}
		if {[info exists ::isa] && $::isa == 1} {
		append not ".  ! : $::isanick, : $game(points)"
		}
		if {[info exists ::auisa] && $::auisa == 1} {
		append not ". -! : $::auisanick, : $game(points)"
		}
		
			
			if {$chan != $game(chan)} {
			append not "\00310.       \002\00312 $game(chan)\017."}
	} else { append not "    .  \002!\002  .\017" }
	if {$handle != "*" && [passwdok $handle -]} {
		global botnick
		append not " \| \00310   -\00303 /msg $botnick pass \002\002\00310 -   ,          ."
	}
	putfast "notice $nick :$not"
	#putfast "PRIVMSG $chan :::Quiz::\002DEBUG\002: isa=$::isa :: auisa=$::auisa :: qidanswer=$::qidanswer"
}
###   
proc ::tpub::tmr_next {qid} { 
variable game
variable conf
global isa isanick isastavka sghand drinkname qidanswer anagrgame isau auisa auisanick austavka au_ch;
	if {![info exists game] || ![info exists game(question)] || $qid != $game(qid)} { return }

	
	if {[info exists isau] && $isau == 1} {putfast "PRIVMSG $game(chan) :\00314   ! ."}
	
	
	set game(hint1d) 0
	#      ""
	set game(lst_user) ""
	set game(lst_cnt) 0
	set game(extra) 0
	set isau 0
	if [info exists game(alreadyhint)] { unset game(alreadyhint) }
	if [info exists game(topsent)] { unset game(topsent) }
	if [info exists game(wonsent)] { unset game(wonsent) }
	# ,        
	set ct [checktime]
	#   
	if {!$ct || [incr game(cnt_lost)] == $conf(lostanswrs)} {
		if {$game(cnt_lost) == $conf(lostanswrs)} {
			set msg "        ."
		} else {
			set msg "       "
		}
		if {$game(qid)} { append msg " [lindex {.   } [numgrp $game(qid)]] $game(qid) [lindex {.   } [numgrp $game(qid)]], " }
		if {$game(cnt_won)} {
			append msg "   $game(cnt_won)    ."
		} else {
			append msg "    ."
		}
		putmsg $game(chan) "\00304$msg   [game_time].\003"
		if {$conf(modset) eq 1} {putserv "MODE $game(chan) +c"}

				if {[expr ([clock seconds] - $game(started))] > [getuser $conf(owner) XTRA TIMEREC]} {
	setuser $conf(owner) XTRA TIMEREC [expr ([clock seconds] - $game(started))]
	setuser $conf(owner) XTRA QUESTCOUNT $game(qid)
	
}	
	
		unset game
		variable g; catch { unset g } err
		return
	}
set phrasesans {
"\00310  ?     ..."
"\00310     ..."
"\00310   ,    ,  !"
"\00310,   !?\00307 =)\00310"
"\00310    ..."
}
	#  { }  
	if {([string match *\{* [lindex $game(question) 1]])} {
		set rarange [string length [lindex $game(question) 1]]
		set rarange [incr rarange -3]
		set rans [string tolower [string range [lindex $game(question) 1] 2 $rarange]]
	} else {
		set rans [string tolower [lindex $game(question) 1]]
	}
####&& $anagrgame != "0" 
	
		if {[info exists conf(showright)] && $conf(showright)} {
	    if {$isa == 1} {
		if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
		putfast "privmsg $game(chan) :\00303$isanick\00310     ,   - \00304$rans\00310. \00303$isanick\00314 \00310  \00304$isastavka\00310 [lindex {.   } [numgrp $isastavka]].\003"
	 	if {[validuser [nick2hand $isanick]]} {
				set hand [nick2hand $isanick] } else { set hand $isanick }
					set place [place $hand]
					set place1 [place1 $hand]
		array set usr [users get $hand]
		
		#  
		catch { incr usr(score) [expr $isastavka * -1] }
		catch { incr usr(scoremonth) [expr $isastavka * -1] }
		catch { incr usr(scoreday) [expr $isastavka * -1] }
		users set [list $hand [array get usr]]
		if { [place $hand] > $place } { putfast "privmsg $game(chan) :\00310[expr {[users isremort $hand] ? "\002$isanick\002" : $isanick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 ]\     ,   \002\002\00304[place_ext [place $hand] $place]\00310!  ,  \;)\003" }
		if { [place1 $hand] > $place1 } { putfast "privmsg $game(chan) :\00310[expr {[users isremort $hand] ? "\002$isanick\002" : $isanick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 ]\    ,   \002\002\00304[place_ext_mon [place1 $hand] $place1]\00310!  ,  \;)\003" }

		
		}  
		 if {[info exists qidanswer] && $qidanswer != "123"  } {
		  if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
		    putfast "privmsg $game(chan) :\00303   ,    \00304$qidanswer\00303.\003"
		 } 
		 if {[info exists anagrgame(slovo)] }  {
		 if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
		 putfast "privmsg $game(chan) :\00303   ,   - \00304$anagrgame(slovo)\00303.\003"
		 #unset anagrgame(slovo)
		 }
		 ####################################
		  if {$auisa == 1} {
		  if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
		putfast "privmsg $game(chan) :\00303$auisanick\00310,   -,   - \00304$rans\00310. \00303$auisanick\00310, \00314 \00310  \00304$austavka\00310 [lindex {.   } [numgrp $austavka]].\003"
	 	if {[validuser [nick2hand $auisanick]]} {
				set hand [nick2hand $auisanick] } else { set hand $auisanick }
					set place [place $hand]
					set place1 [place1 $hand]
		array set usr [users get $hand]
		
		#  
		catch { incr usr(score) [expr $austavka * -1] }
		catch { incr usr(scoremonth) [expr $austavka * -1] }
		catch { incr usr(scoreday) [expr $austavka * -1] }
		users set [list $hand [array get usr]]
		if { [place $hand] > $place } { putfast "privmsg $game(chan) :\00310[expr {[users isremort $hand] ? "\002$auisanick\002" : $auisanick}]   \[ \00304\002\002[::tpub::place $hand]\002\002\00310 ]\     ,   \002\002\00304[place_ext [place $hand] $place]\00310!  ,  \;)\003" }
		if { [place1 $hand] > $place1 } { putfast "privmsg $game(chan) :\00310[expr {[users isremort $hand] ? "\002$auisanick\002" : $auisanick}]   \[ \00304\002\002[::tpub::place1 $hand]\002\002\00310 ]\    ,   \002\002\00304[place_ext_mon [place1 $hand] $place1]\00310!  ,  \;)\003" }

		
		set auisa 0
		set auisanick "000"

		if {[info exists sch] && $sch >0} {set sch 0}
		set ::tpub::auusers {}
			##################################################
			set sn {}
			foreach au_user [lindex [chanlist $game(chan)]] {
			lappend sn $au_user
			set a1 0
			set a2 ""
			while {$a1 < [llength $sn]} {
			append a2 "v"
			incr a1
			}
			}
		 putserv "mode $game(chan) -m+$a2 [join [lrange $sn 0 9]]"
		 if {[expr [string length $a2] >10]} {	 putserv "mode $game(chan) +$a2 [join [lrange $sn 10 19]]"}
		 set a2 ""
			##################################################
		} 
		###################################
		 
		 
		 if {$isa != "1" && $qidanswer == "123" && ![info exists anagrgame(slovo)] && $isa != "1" && $au_ch != "1" } {
		  if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
		    putfast "privmsg $game(chan) :\00303    ,   - \00304[tolower $rans]\00303.\003"
		 } 
		 #
	    
	} else {
	    if {$isa == 1} {
		putfast "privmsg $game(chan) :\00303$isanick\00307     . \00303$isanick\00307   \00303$isastavka\00307 [lindex {.   } [numgrp $isastavka]].    $conf(nextq) .\003"
		 array set usr [users get $hand]
		 set debscore $user(score)
		 #  
		 catch { incr usr(score) [expr $isastavka * -1] }
		 catch { incr usr(scoremonth) [expr $isastavka * -1] }
		  catch { incr usr(scoreday) [expr $isastavka * -1] }
		 users set [list $hand [array get usr]]
 		 putlog "\00304DEBUG: NICK: $isanick ($sghand). Score was: $debscore. Loose: $isastavka. Score now: $user1(score)."
	    } 
	 	  if {[info exists qidanswer] } {
		    putfast "privmsg $game(chan) :\00303   ,    \00304$qidanswer\00303.\003"
		 unset qidanswer
		 } 
		 	 if {[info exists anagrgame(slovo)]}  {
		 putfast "privmsg $game(chan) :\00303 !!#2    ,    \00304$anagrgame(slovo)\00303.\003"
		 } 
		 ####################################
		  if {$auisa == 1} {
		putfast "privmsg $game(chan) :\00303$auisanick\00310,   -,   - \00304$rans\00310. \00303$auisanick\00310, \00314 \00310  \00304$austavka\00310 [lindex {.   } [numgrp $austavka]].\003"
	 	if {[validuser [nick2hand $auisanick]]} {
				set hand [nick2hand $auisanick] } else { set hand $auisanick }
		array set usr [users get $hand]
		
		#  
		catch { incr usr(score) [expr $austavka * -1] }
		catch { incr usr(scoremonth) [expr $austavka * -1] }
		catch { incr usr(scoreday) [expr $austavka * -1] }
		users set [list $hand [array get usr]]
		set auisa 0
		set auisanick "000"
		if {[info exists sch] && $sch >0} {set sch 0}
		set ::tpub::auusers {}
		putserv "mode $game(chan) -m"
			##################################################
			set sn {}
			foreach au_user [lindex [chanlist $game(chan)]] {
			lappend sn $au_user
			set a1 0
			set a2 ""
			while {$a1 < [llength $sn]} {
			append a2 "v"
			incr a1
			}
			}
		 putserv "mode $game(chan) -m+$a2 [join [lrange $sn 0 9]]"
		 if {[expr [string length $a2] >10]} {	 putserv "mode $game(chan) +$a2 [join [lrange $sn 10 19]]"}
		 set a2 ""
			##################################################
		#############################################
		} else {
		 
		    putfast "privmsg $game(chan) :\00303    .    $conf(nextq) .\003"
		 }
     #putfast "privmsg $game(chan) :\00303   ,    \00304$$anagrgame(slovo)\00310.\003"
	 	
	}
	set isa 0
	set auisa 0
	set auisanick "123"
	set isanick "123"
	set sghand "123"
	set au_ch 0
	unset game(question)
	killtm
	utimer $conf(nextq) ::tpub::tmr_ask
}

###   
proc ::tpub::tmr_hint {qid {len 1}} { global anagrgame anagrqid
variable game; variable conf	
	if {![info exists game] || ![info exists game(question)] || [lsearch -exact $game(question) "3333"]>0 || $qid != $game(qid) || [info exists game(extra)] && $game(extra) > 0} { return }
  if {![info exists game(alreadyhint)]} { set game(alreadyhint) 1 }
  if {$conf(hinttype) == 1} {
	if {[expr 3 - $len] != 0} { incr game(points) -1 } else { return }
	set answer [join [string tolower [lindex $game(question) 1]]]
	set rbi [expr int([expr $len * [string length $answer] * $conf(hprc)])]
	if {$len >= [expr [string length $answer] - 1]} { return }
	set bb [expr [string length $answer] - $len - 1]
	set rbt [string range $answer 0 $rbi]
	set rbl [string length $rbt]
	set hint "[string repeat [string index $conf(zv) 0] [expr [string length $answer] + 1]]"
	set hint [string replace $hint 0 $rbl $rbt]
}
if {$conf(hinttype) == 2} {
	if {[expr 3 - $len] != 0} { incr game(points) -1 } else { return }
	set answer [join [string tolower [lindex $game(question) 1]]]
	if {$len >= [expr [string length $answer] - 1]} { return }
	set zv $conf(zv)
	set k $len
	set bb [expr [string length $answer] - $len - 1]
	while {$k<=$len && [string length $answer] > 7} {
	set k [rand [expr [string length $answer] + 1]]
	}
	set rb [string range $answer 0 $k] 	
	set rb [string range $rb end end] 
	set hint "[string tolower [string range $answer 0 [expr $len - 1]]][string repeat [string index $zv 0] [expr $bb + 1]]"
	set hint [string replace $hint $k $k $rb]
	if {[string length $answer] > 7} { 
		set m [string range $answer end end]
		set hint [string replace $hint [expr [string length $hint] - 1] [expr [string length $hint] - 1] $m]
	}
	set hb 1
	while {[expr $hb + 6] < [string length $answer]} {
		set m [rand [expr [string length $answer] + 1]]
		set mm [string range $answer 0 $m]
		set mm [string range $mm end end]
		set hint [string replace $hint $m $m $mm]
		set hb [expr $hb + 6]
	}
}	
if {$conf(hinttype) == 3} {
	set answer [join [string tolower [lindex $game(question) 1]]]
	if {$len >= [expr [string length $answer] - 1]} { return }
	set hlet [expr $len - 1]
	set hint "[string repeat [string index $conf(zv) 0] [string length $answer]]"
	set m [string range $answer $hlet $hlet]
	set hint [string replace $hint $hlet $hlet $m]
  while {[expr $hlet + 5] < [string length $answer]} {
  	set m [string range $answer [expr $hlet + 5] [expr $hlet + 5]]
		set hint [string replace $hint [expr $hlet + 5] [expr $hlet + 5] $m]
		set hlet [expr $hlet + 5]
	}
}
if {$conf(hinttype) == 4} {
	set answer [join [string tolower [lindex $game(question) 1]]]	
	
	regsub -all -nocase -- {\{} $answer "" answer
	regsub -all -nocase -- {\}} $answer "" answer
	#putlog "$answer"
	
	if {[info exists anagrgame(slovo)]} { set answer $anagrgame(slovo)}
	if {[string length $answer] < 3} { return }
	if {[expr 3 - $len] != 0} { incr game(points) -1 } else { return }
	set hint ""
	set zv $conf(zv)
	set answer [split $answer]
	foreach item $answer {
		set hintmes "[string repeat [string index $zv 0] [string length $item]]"
		if {[string length $item] < 3} { lappend hint $hintmes; continue } elseif {[string length $item] < 5}	{ set ind [expr $len - 1] } elseif {[string length $item] < 8} { set ind $len } else { 
			set hb 2
			set ind $len
			while {[expr $hb + 6] < [string length $item]} {
				incr ind
				set hb [expr $hb + 6]
			}
			set hr 1 
			while {[expr $hr + 6] < [string length $item]} {
				if {![info exists indx]} {set indx [expr $len - 1]} 
				incr indx
				set hr [expr $hr + 6]
			}
		}
			set rbt [string range $item 0 $ind]
			set hintmes [string replace $hintmes 0 $ind $rbt]
			if {[info exists indx]} {
			set indx [expr [string length $item] - $indx]
			set rbt [string range $item $indx end]
			set hintmes [string replace $hintmes $indx end $rbt]
		}
		unset ind 
		if {[info exists indx]} {unset indx}
		lappend hint $hintmes
	}
	#set hint [join $hint]
}	


	regsub -all -nocase -- {\[} $hint "" hint
	regsub -all -nocase -- {\]} $hint "" hint
	regsub -all -nocase -- {\\} $hint "" hint
	regsub -all -nocase -- {\/} $hint "" hint
if {$conf(modset) eq 1} {putfast "MODE $game(chan) -c"}
	putmsg $game(chan) "\00312:\00304 [tolower $hint]\003"
	utimer $conf(thint2) [list ::tpub::tmr_hint $game(qid) [incr len]] 
}
###  
namespace eval tpub {
	variable conf
	if {![set count [question count]]} { set count [question rehash] }
	if [info exists anagrgame(slovo)] { unset anagrgame(slovo) }
	switch -- $::tpub::conf(qmode) {
	"1" {set type ""}
	"2" {set type " "}
	default {set type "\00304\002ERROR!  !\017"}
	}
	putlog "Quiz (), $qcount [lindex {.   } [numgrp $qcount]], $count .    : $type"
}
proc ::tpub::dcc_hint {hand idx text} { variable game
	if {![info exists game]} {
		putidx $idx "  ."
		return
	}
	if {![info exists game(question)]} {
		putidx $idx "   ."
		return
	}
	putidx $idx ": [string map { } [lindex $game(question) 1]]"
}
#   
proc ::tpub::dcc_won {hand idx text} {
	if {![string length $text]} {
		putidx $idx "Usage: won <nick>"
		return
	}
	if {![validuser [set nick [lindex [split $text] 0]]]} {
		putidx $idx "Can't find anyone with such a nick."
		return
	}
	array set user [set xtra [users get $nick]]
	if {$xtra == ""} {
		putidx $idx "User $nick is not known to have played quiz."
	} elseif  {[catch {
		putlog "#$hand# won $nick"
		# count place number
		set place -1
		for {set list [users list]; set i 0} {$i < [llength $list]} {incr i} {
			if {![string compare -nocase $nick [lindex [lindex $list $i] 0]]} {
				set place $i
				break
			}
		}
		incr place
		set fame [expr {$place ? ", place: $place" : ""}]
		putidx $idx "User: $nick, score: $user(score), answers: $user(answers) (max: $user(cont)), speed: $user(quick) sec.$fame"
		if {[info exists user(memo)]} {
			putidx $idx "$nick has a memo: [string map { } $user(memo)]"
		}
	}]} { putidx $idx "Error displaying information for $nick, try: .tcl getuser $nick xtra quiz" }
	return 0
}
#  
proc ::tpub::backup {min hour day month year} {
		variable conf
		putlog "Backuping base in $conf(backupfile)."
		catch { dcc_score "backup" "buckup" "export $conf(backupfile)" } err
}
proc ::tpub::mysql_cusers {hand idx text} { variable game
set users [userlist]
mysql_connect drakon localhost drakon --
foreach item $users {
	array set user [set xtra [users get $item]]
	  mysql_query "INSERT INTO users VALUES ('', '[mysql_escape $item]', '[expr {[info exists user(last)] ? $user(last) : ""}]', '[expr {[info exists user(cont)] ? $user(cont) : ""}]', '[expr {[info exists user(score)] ? $user(score) : ""}]', '[expr {[info exists user(quick)] ? $user(quick) : ""}]', '[expr {[info exists user(answers)] ? $user(answers) : ""}]', '[expr {[info exists user(tremort)] ? $user(tremort) : ""}]', '[expr {[info exists user(remort)] ? $user(remort) : ""}]', '[expr {[info exists user(email)] ? $user(email) : ""}]', '[expr {[info exists user(memo)] ? $user(memo) : ""}]' );"
  }
}
# 
proc ::tpub::dcc_score {hand idx text} { variable game
	set fname [lindex [split $text] 1]
	switch -exact -- [lindex [split $text] 0] {
		"export" {
		   if { $hand == "backup" && $idx == "backup" } {
			if {$fname == ""} {
				putlog "\[buckup error\] bad file name"
				return 0
			}
			if {[catch {open $fname w} fileID]} {
				putlog "\[buckup error\] cant open backup file"
				return 0
			}
			set count 0
			foreach user [lsort [userlist]] {
				if {[set xtra [getuser $user xtra quiz]] == ""} { continue }
				puts $fileID "$user $xtra"
				incr count
			}
			close $fileID
			putlog "$count record(s) backuped to $fname"
	      } else {
		  if {$fname == ""} {
				putidx $idx "Usage: .score export filename"
				return 0
			}
			if {[catch {open $fname w} fileID]} {
				putidx $idx "Failed to open $fname for writing."
				return 0
			}
			set count 0
			foreach user [lsort [userlist]] {
				if {[set xtra [getuser $user xtra quiz]] == ""} { continue }
				puts $fileID "$user $xtra"
				incr count
			}
			close $fileID
			putidx $idx "$count record(s) exported to $fname"
			putcmdlog "#[idx2hand $idx]# score export $fname"
		  }
		}
		"import" {
			if {$fname == ""} {
				putidx $idx "Usage: .score import filename"
				return 0
			}
			if {[catch {open $fname r} fileID]} {
				putidx $idx "Failed to open $fname for reading."
				return 0
			}
			# remove old records
			foreach item [userlist] { setuser $item xtra quiz }
			set count 0
			set fails 0
			while {![eof $fileID]} {
				if {[set line [string trim [gets $fileID]]] == ""} { continue }
				if {![validuser [set user [lindex [split $line] 0]]]} {
					incr fails
				} else {
					setuser $user xtra quiz [join [lrange [split $line] 1 end]]
					incr count
				}
			}
			close $fileID
			putidx $idx "$count record(s) imported, $fails failed to import."
			putcmdlog "#[idx2hand $idx]# score import $fname"
		}
		default {
			putidx $idx "Usage: .score {import|export} filename"
			return 0
		}
	}
}

proc killtm { } {
    foreach tms "[utimers]" {
	if {([llength $tms] != 0)} {
	    set tmc [lindex $tms 1]
		set aatt [string range $tmc 2 5]
		if {$aatt != "tpub"} {continue}
           set tid [lindex $tms 2]
	    #putlog "Killing timer $tid"
    	    killutimer $tid
	    unset tmc
	    unset tid
	    unset tms
	}
    }
}
proc ::tpub::z_join { nick host hand chan } {
	variable conf
	variable game
	global lock
		if {[info exists lock] && $lock eq 1} {return}

	#if {$hand == "*"} { return }
	if {$nick == $hand} { set nick1 $nick }
	if {$nick != $hand} { set nick1 "$nick \00310aka \00304$hand\003" }
	#if {$chan != $conf(channels)} { return }
	
	if {[lsearch -exact [split [string tolower $conf(channels)]] [string tolower $chan]] == -1 || $hand == "*"} { return }
	
	setuser $hand XTRA TMPTIME [clock seconds]
	array set usr [users get $hand]
	if {![info exists usr(score)]} {return}
				set ko 0
				foreach item $conf(drank) { 
				if {$usr(score)<=$item} { set honor [lindex $conf(rank) $ko]; break}
				incr ko
				} 
				if {![info exists honor]} {set honor $conf(dmax)}
	set place [place $hand]
	set place1 [place1 $hand]
	if {$place <= 0} {putlog 0; return }
	
	append msg "\00314\[ \00304\002\002$place\002\002\ \00312\(\00303\002\002$usr(score)\00312\)\00307[expr {[info exists usr(scoremonth)] && $usr(scoremonth) != 0 ? "\00310 | \00304$place1\002\002\00310 \00312\(\00303\002\002$usr(scoremonth)\00312\)" : ""}] \00314\]\00310 [expr {[users isintop $hand] || [users isremort $hand] ? "\002+\002" : ""}]\00303[expr {[users isremort $hand] ? "\002$nick1\002" : $nick1}] \00310\[\00305 [expr {[info exists usr(tremort)] ? $usr(tremort) : $honor}]\00310 \]"
	if  {[info exists usr(memo)]} {
		if {[users isintop $hand] || [string first o [chattr [nick2hand $nick]]] != -1} {
			append msg "\00310\[ \00305\002\002$usr(memo)\002\002\00310 \]"
			}
	}
	if {$conf(modset) eq 1} {putfast "MODE $chan -c"}
putfast "privmsg $chan :$msg" 
if {$conf(modset) eq 1} {putfast "MODE $chan +c"}
}
proc z_quit {nick host hand chan text} {
	
	set shand [nick2hand [finduser "$nick!$host"]]
		if {$shand == "*"} { return }
	
	set ttime [getuser $hand XTRA TMPTIME]
		if {[string trim $ttime] == ""} {set ttime 0; return}
	
	set altime [expr [clock seconds] - $ttime]
		if {[string trim $altime] == ""} {set altime 0} 
	
 	set btime [getuser $hand XTRA TIME]
	set altime [expr $btime + $altime]
	
      setuser $hand XTRA TIME $altime
}
proc z_part {nick host hand chan text} {
	set shand [nick2hand [finduser "$nick!$host"]]
		if {$shand == "*"} { return }
	
	set ttime [getuser $hand XTRA TMPTIME]
		if {[string trim $ttime] == ""} {set ttime 0; return}
	
	set altime [expr [clock seconds] - $ttime]
		if {[string trim $altime] == ""} {set altime 0} 
	
	set btime [getuser $hand XTRA TIME]
	set altime [expr $btime + $altime]
	
	setuser $hand XTRA TIME $altime
}
# this code originaly was taken from egglib (c)2004 eggdrop.org.ru - Russian Eggdrop Resource.
 set dur {
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 	{	{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}} {{} {} {} {}}
 		{{} {} {} {}}}
 }
 proc ::tpub::duration { time {mode 0} {text ""} } {
 	global dur
 	set ret ""; set m $mode; if { $text == "" } { set expire [::duration $time]} { set expire $text }
 
 	for { set s1 0 } { $s1 <= 6 } { incr s1 } {
 	
 		if { $mode == 3 } { set s2 [expr {6-$s1}] } { set s2 $s1 }
 		switch -exact $s2 {
 			0 {	set re {([0-9]+?)\ year} }
 			1 {	set re {([0-9]+?)\ month} }
 			2 {	set re {([0-9]+?)\ week} }
 			3 {	set re {([0-9]+?)\ day} }
 			4 {	set re {([0-9]+?)\ hour} }
 			5 {	set re {([0-9]+?)\ minute} }
 			6 {	set re {([0-9]+?)\ second} }
 		}
 		
 		# for year, day
 		if { [regexp -nocase -- $re $expire g d] } {
 			set k $d
 			while {$k>10} { incr k -10 }
 			if {($d>10 && $d<21) || $k>4 || $d==0} {
 				append ret " $d [lindex [lindex [lindex $dur $m] $s2] 2]"
 			} elseif {$k==1} {
 				if {$d==1} {
 					append ret " $d [lindex [lindex [lindex $dur $m] $s2] 0]"
 				} else {
 					append ret " $d [lindex [lindex [lindex $dur $m] $s2] 3]"
 				}
 			} elseif {$k<5} {
 				append ret " $d [lindex [lindex [lindex $dur $m] $s2] 1]"
 			} else {
 				append ret " $d [lindex [lindex [lindex $dur $m] $s2] 2]"
 			}
 		}	
 		
 		if { $m == 3 && $ret != "" } { set m 2 }
 	}
 	set ret [string trim $ret]
 	return $ret
 }
 
#  !/!ping
proc ::tpub::cmd_lag {nick chan text} { return [cmd_ $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} { return [cmd_ $nick $chan $text] }
proc ::tpub::cmd_ {nick chan text} {
  putfast "PRIVMSG $nick :\001PING [unixtime]\001"
  putlog "   $nick"
  return 0
}
proc ::tpub::ver_resp {nick uhost hand botnick key arg} {
  variable conf
  if {$key == "VERSION" && $hand != $::owner} {
  putlog "$nick   "
   #putquick "notice $nick :$conf(game_info) \[  [set ::tpub::qcount] [lindex {.   } [numgrp [set ::tpub::qcount]]]\]"
  }
}
if {[info exists ::tpub::conf(mpeople)]} {
   bind time - "?0 * * * *" ::tpub::checkpl
}
proc ::tpub::checkpl {min hour day month year} {
		variable conf; variable g
if {![info exists g]} { return}
set z $g
set k 0
set b 0
foreach user $g {
	set tto [getchanidle $user [lindex $conf(channels) 0]]
	putlog "$tto ---"
	if {$tto>=$conf(tidle)} { set z [lreplace $z [expr $k - $b] [expr $k - $b]]; incr b; putmsg [lindex $conf(channels) 0] "\00304$user\003        ." }
	incr k
 }
set g $z
global botnick
if {![llength $g] || [llength $g] < $conf(tidle)} {catch {unset g} err; cmd_stop $botnick [lindex $conf(channels) 0] ""}
}
# disable eggdrop's built-in help
unbind msg - help *msg:help
###   
proc ::tpub::cmd_ {nick chan text} {return [cmd_cheat $nick $chan $text] }
proc ::tpub::cmd_jndtn {nick chan text} {return [cmd_cheat $nick $chan $text] }
proc ::tpub::cmd_answer {nick chan text} {return [cmd_cheat $nick $chan $text] }
proc ::tpub::cmd_cheat {nick chan text} { variable game
	variable conf
	global isa auisa
  if {$text == "?help?"} { return [usage $nick $chan cheat "" "   ,       $conf(cheatmin)         $conf(cheat) "] }
  if {[info exists isa] && $isa == 1 || [info exists auisa] && $auisa == 1} {return}
  set hand [nick2hand $nick]
	array set usr [users get $hand]
	if {![info exists game] || $game(chan) != $chan || ![info exists game(question)]} {
		return 0
	}
	if {$conf(cheatenable) == 0} {
	  putfast "notice $nick :  ."
 	  return 0
	}
	if {$usr(score)<$conf(cheatmin) && ![users isremort $hand]} {
        putpvt $nick $chan "   ,    .  $conf(cheatmin) ."
 	  return 0
	} else {
        set answer [join [lindex [lindex $game(question) 1] 0]]
	  incr usr(score) [expr $conf(cheat)*-1]
	  incr usr(scoremonth) [expr $conf(cheat)*-1]
	  incr usr(scoreday) [expr $conf(cheat)*-1]
	  users set [list $hand [array get usr]]
	  putfast "notice $nick : : $answer."
	  putfast "notice $nick :    $conf(cheat)   ."
	}
} 
proc ::tpub::anticheat { mes } {
	variable conf
#	if {$mes == ""} {return $mes}
	foreach item $conf(cdword) {
		set tr [expr [rand [llength [split $mes]]] - 1]
		for {set i 0} { $i < $tr} {incr i} {
			if {[rand $conf(profcd)] <= 1} {
				regsub [lindex $item 0] $mes [lindex $item 1] mes
			}
		}
	}
	set tr [rand 4]
	for {set i 0} { $i < $tr } {incr i} {
		if {[rand $conf(profcd)] <= 1} {
		regsub \x20 $mes \x0a0 mes
		}
	}
	return $mes
}

proc ::tpub::monthremove {min hour day month year} {variable conf
		set b {}; set e {}
		foreach a [::tpub::users listmonth] {lappend b [lindex $a 1]}; set monscrs [expr [string map {" " +} $b]]
		foreach d [::tpub::users ansmonth] {lappend e [lindex $d 1]}; set monanswrs [expr [string map {" " +} $e]]
		
		
		foreach channel [split $conf(channels)] {
		if {$conf(modset) eq 1} {putfast "MODE $channel -c"}
		putserv "PRIVMSG $channel :\00310  .      \00304$monscrs\00310 [lindex {.   } [numgrp $monscrs]]   \00304$monanswrs \00310[lindex {.   } [numgrp $monanswrs]]. \00312   !!!\003"
		putserv "PRIVMSG $channel :\00304   !    !\003"
		if {$conf(modset) eq 1} {putserv "MODE $channel +c"}
		}
		
		
		
		foreach q [userlist] {
			array set data [getuser $q xtra quiz]
			if {[info exists data(answers)]} {
				set data(scoremonth) 0
				set data(answersmonth) 0			
				setuser $q xtra quiz [array get data]
			}
			array unset data
	}
}

proc ::tpub::dayremove {min hour day month year} {variable conf
	
	
	foreach qd [userlist] {
			array set data [getuser $qd xtra quiz]
			if {[info exists data(answers)]} {
				set data(scoreday) 0
				set data(answersday) 0			
				setuser $qd xtra quiz [array get data]
			}
			array unset data
	}
}
##    -
bind pub n !sur ::tpub::suremove
proc ::tpub::suremove {nick uhost hand chan text} {variable conf
	set i 0
	
	if {$text != "" && [string match "augames" $text] || [string match "anwins" $text] || [string match "supergames" $text] || [string match "answers" $text] || [string match "quick" $text] } {} { putserv "NOTICE $nick :Wrong parameters!"; return}
	foreach qds [userlist] {
	
			array set data [getuser $qds xtra quiz]
			if {![info exists data([lindex $text])]} {
			incr i
				set data([lindex $text]) 0
				setuser $qds xtra quiz [array get data]
			}
			array unset data
	}
	putserv "PRIVMSG $chan :Done. Total replaces: $i."
}

proc supergame_off {nick1 chan1 nextq offtime} {
 variable game; variable conf
 global supergame_nick issupergame
 if {$issupergame eq 0} {return}
 if {$conf(modset) eq 1} {putfast "MODE $chan1 -c"}
 putfast "privmsg $chan1 :\00303$nick1\00314,        \00303 $offtime\00314 . ."
 set supergame_nick "123"
 set issupergame 0
 set ::tpub::game(lst_cnt) 0
 #putmsg $chan1 "\00310   $nextq !\00"
 utimer $nextq ::tpub::tmr_ask
}
bind dcc m usersfix ::tpub::usersfix
proc ::tpub::usersfix {hand idx text} {
	set i 0
	foreach q [userlist] {
		if {![validuser $q]} {continue}
		if {[getuser $q xtra quiz] != ""} {
			 users check [list $q $q]
			 incr i
		}			
	}
	putlog "Usersfix done! $i users have been checked."
}
proc ::tpub::cmd_ {nick chan text} { return [cmd_report $nick $chan $text] }
proc ::tpub::cmd_htgjhn {nick chan text} { return [cmd_report $nick $chan $text] }
proc ::tpub::cmd_report {nick chan text} { variable game; variable conf
	if {$text == "?help?"} { return [usage $nick $chan report "" "        .      .          "] }
	if {![info exists game] || $game(chan) != $chan || ![info exists game(question)]} {
    putfast "notice $nick :     :)"
		return 0
	}
  set del_question $game(question)
  set f_bad [open $conf(reportquestions) a+]
  puts $f_bad $del_question
  close $f_bad
  putfast "notice $nick :         ,       .       !"
	}
	
proc helping_v {nick uhost chan text arg} { 
variable game
variable conf
puthelp "notice $nick :    \"\" (  -    )"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)start)\00310 -     ,     .\003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)stop)\00310 -    .     5- , \00304\002*\002\00310  ,  .\003"
puthelp "notice $nick :\00304$conf(pref) $conf(pref) ($conf(pref)next)\00310 -   .    5-   \00304\002*\002\00310.\003"
puthelp "notice $nick :\00304$conf(pref) $conf(pref) $conf(pref) ($conf(pref)x $conf(pref)X $conf(pref)hint)\00310 -   .    1     2- .       1   \003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)answer $conf(pref)cheat)\00310 -         ,       .       20 .\003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)extra)\00310 -    . \"\"      .  \00304\002*\002\00310  \00304\002**\002\00310.\003"
puthelp "notice $nick :\00304$conf(pref) \00310 -        ,  "
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)place)\00310 -      ,      ,    .    \00304$conf(pref) \<\>\00310 -  ,  \<'\>\003"
puthelp "notice $nick :\00304$conf(pref)_ ($conf(pref)place_ans)\00310 -      ,      ,    .    \00304$conf(pref)_ \<\>\00310 -  ,  \<'\>\003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)won)\00310 -      .    \00304$conf(pref) \<\>\00310 -   \<'a\>\003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)top)\00310 -    .        10-,  5-.    \00304$conf(pref) \<  5  10\>\00310 -     .\003"
puthelp "notice $nick :\00304$conf(pref) ($conf(pref)records)\00310 -   .\003"
puthelp "notice $nick :\00304$conf(pref) $conf(pref) ($conf(pref)c $conf(pref)stat)\00310 -    -   ,       ..\003"
puthelp "notice $nick :\00310_____________"
puthelp "notice $nick :\00310  \00304\002*\002\00310 - ,    (    \00304o\00310),         @"
puthelp "notice $nick :\00310  \00304\002**\002\00310 -    (\00312+m\00310),   (\00309+n\00310)"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
#puthelp "notice $nick :"
}
######### [place_ext $place [place $hand]]

#    ( 30 )

bind time - "00 * * * *" ::tpub::top_write
bind time - "30 * * * *" ::tpub::top_write

#    ftp

#  ftp
bind time - "01 * * * *" 	::tpub::ftp
bind time - "31 * * * *" 	::tpub::ftp





proc ::tpub::ftp {min hour day month year} {
	variable conf
	if {$conf(ftp) eq 0} {return}
	if {![file exist $conf(topfile)]} {	putlog "sendftp: File $conf(topfile) does not exist."; return}
	putlog "Sending top-file..."
	set pipe [open "|ftp -n $conf(host)" w]
	puts $pipe "user $conf(login) $conf(pass)"
	puts $pipe "bin"
	puts $pipe "put $conf(topfile) $conf(folder)"
	puts $pipe "put $conf(topfile2) $conf(folder2)"
	puts $pipe "quit"
	close $pipe
	return 1
}


#  

proc ::tpub::top_write {minute hour day month year} { 
	global server network
	variable game
	variable conf
	set maxtop $conf(maxtop)
	incr maxtop -1
	set place 0
	set writefile [open $conf(topfile) w]
	
	puts $writefile "<html><head><title>  \"\"</title><meta http-equiv=\"content-type\" content=\"text/html;charset=windows-1251\"><meta\ http-equiv=\"Expires\" content=\"0\"><\/head><body>"
	puts $writefile "<p align=\"center\"><i><font size=\"2\"> \"\"</i><br>$conf(network)</font><br><font size=\"2\">(<a href=irc://$server/[string range $conf(channels) 1 end]>$conf(networkaddr)<\/a>,  [lindex $conf(channels) 0])<br><br>  <br>( <a href=$conf(linkscore)><b><\/b><\/a> \| <a href=$conf(linkanswers)><\/a> )<\/font><\/p>"
	puts $writefile "<p align=\"center\"><b><font size=\"2\">(  )</b></font></p>"
	puts $writefile "<center><table>"	
	puts $writefile "<html><head><meta http-equiv=\"content-type\" content=\"text/html;charset=windows-1251\"><meta\ http-equiv=\"Expires\" content=\"0\"><\/head><body><table>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b>()</b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b>  <br>  </b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br>\(\)</b><tr>"
      foreach item [lrange [users list] 0 $maxtop] {
                   array set user [users get [lindex $item 0]] 
			 if {[expr {$place % 2}]} {
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[incr place]"
		set honor "";set ko 0
		foreach item1 $conf(drank) { 
			if {$user(score)<=$item1} { set honor [lindex $conf(rank) $ko]; break}
		incr ko }
		if {$honor==""} {set honor $conf(dmax)}
		if {[info exists user(tremort)]} { set honor $user(tremort) }  

                   puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[lindex $item 0](<font color=red>$honor<\/font>)"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[lindex $item 1]"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(answers)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(quick)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(cont)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(supergames)"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(augames)"
			puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(anwins)" 
			
	if {$user(score)!=0 && $user(answers) != 0} {
	set sball [expr 1.0 * $user(score) / $user(answers)]
	if {[info exists user(remort)]} {set sball [expr ( 1.0 * $user(score) + $conf(rscore)*$user(remort) ) / $user(answers)]}
	if {[regexp -nocase -- {^(\d+)\.(\d{1,3})} $sball a sbal b] } { set sbal "$sbal.$b"	}
	} else {set sbal 0}
 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$sbal"   

puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[join [lrange [duration [expr [clock seconds] -$user(last)]] 0 3]]<tr>"
} else {
 			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[incr place]"
			 set honor "";set ko 0
				foreach item1 $conf(drank) { 
				if {$user(score)<=$item1} { set honor [lindex $conf(rank) $ko]; break}
				incr ko } 
				if {$honor==""} {set honor $conf(dmax)}
		if {[info exists user(tremort)]} { set honor $user(tremort) }
                   puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[lindex $item 0](<font color=green>$honor<\/font>)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[lindex $item 1]"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(answers)" 
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(quick)" 
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(cont)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(supergames)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(augames)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(anwins)" 
	if {$user(score)!=0 && $user(answers) != 0} {
	set sball [expr 1.0 * $user(score) / $user(answers)]
	if {[info exists user(remort)]} {set sball [expr ( 1.0 * $user(score) + $conf(rscore)*$user(remort) ) / $user(answers)]}
	if {[regexp -nocase -- {^(\d+)\.(\d{1,3})} $sball a sbal b] } { set sbal "$sbal.$b"	}
	} else {set sbal 0}
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$sbal"         

puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[join [lrange [duration [expr [clock seconds] -$user(last)]] 0 3]]<tr>"
	}

		array unset user
	}

	puts $writefile "</TABLE></center><br>"
	puts $writefile "<center> [ctime [unixtime]]  $::botnick v.[lindex $::version 0], Tcl v.[info patchlevel]</center>"
	puts $writefile "<center>$conf(game_info)</center>"
	puts $writefile "<center> : [countusers],  : $conf(maxtop).</center>"
	puts $writefile "</center></body></html>"

	close $writefile

	set place 0
	set writefile [open $conf(topfile2) w]
	
	puts $writefile "<html><head><title>  \"\"</title><meta http-equiv=\"content-type\" content=\"text/html;charset=windows-1251\"><meta\ http-equiv=\"Expires\" content=\"0\"><\/head><body>"
	puts $writefile "<p align=\"center\"><b><font size=\"2\">(  )</b></font></p>"
	puts $writefile "<p align=\"center\"><i><font size=\"2\"> \"\"</i><br>$conf(network)<br></font><font size=\"2\">(<a href=irc://$server/[string range $conf(channels) 1 end]>$conf(networkaddr)<\/a>,  [lindex $conf(channels) 0])<br><br>  <br>( <a href=$conf(linkscore)><\/a> \| <a href=$conf(linkanswers)><b><\/b><\/a> )<\/font><\/p>"
	puts $writefile "<center><table>"	
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b>()</b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b>  <br>  </b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b><br></b>"
	puts $writefile "<td bgcolor=black style=color:#ffffff align=Center><b> <br>\(\)</b><tr>"
      foreach item [lrange [users list1] 0 $maxtop] {
                   array set user [users get [lindex $item 0]] 
			 if {[expr {$place % 2}]} {
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[incr place]"
		set honor "";set ko 0
		foreach item1 $conf(drank) { 
			if {$user(score)<=$item1} { set honor [lindex $conf(rank) $ko]; break}
		incr ko }
		if {$honor==""} {set honor $conf(dmax)}
		if {[info exists user(tremort)]} { set honor $user(tremort) }  

                   puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[lindex $item 0](<font color=red>$honor<\/font>)"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[lindex $item 1]"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(score)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(quick)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(cont)" 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(supergames)"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(augames)"
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$user(anwins)" 
	if {$user(score)!=0 && $user(answers) != 0} {
	set sball [expr 1.0 * $user(score) / $user(answers)]
	if {[info exists user(remort)]} {set sball [expr ( 1.0 * $user(score) + $conf(rscore)*$user(remort) ) / $user(answers)]}
	if {[regexp -nocase -- {^(\d+)\.(\d{1,3})} $sball a sbal b] } { set sbal "$sbal.$b"	}
	} else {set sbal 0}
 
			 puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>$sbal"   

puts $writefile "<td align=Center bgcolor=#c8d2df nowrap>[join [lrange [duration [expr [clock seconds] -$user(last)]] 0 3]]<tr>"
} else {
 			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[incr place]"
			 set honor "";set ko 0
				foreach item1 $conf(drank) { 
				if {$user(score)<=$item1} { set honor [lindex $conf(rank) $ko]; break}
				incr ko } 
				if {$honor==""} {set honor $conf(dmax)}
		if {[info exists user(tremort)]} { set honor $user(tremort) }
                   puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[lindex $item 0](<font color=green>$honor<\/font>)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[lindex $item 1]"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(score)" 
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(quick)" 
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(cont)" 
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(supergames)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(augames)"
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$user(anwins)" 
	if {$user(score)!=0 && $user(answers) != 0} {
	set sball [expr 1.0 * $user(score) / $user(answers)]
	if {[info exists user(remort)]} {set sball [expr ( 1.0 * $user(score) + $conf(rscore)*$user(remort) ) / $user(answers)]}
	if {[regexp -nocase -- {^(\d+)\.(\d{1,3})} $sball a sbal b] } { set sbal "$sbal.$b"	}
	} else {set sbal 0}
			 puts $writefile "<td align=Center bgcolor=#ffffff nowrap>$sbal"         

puts $writefile "<td align=Center bgcolor=#ffffff nowrap>[join [lrange [duration [expr [clock seconds] -$user(last)]] 0 3]]<tr>"
}

		array unset user
	}

	puts $writefile "</TABLE></center><br>"
	puts $writefile "<center> [ctime [unixtime]]  $::botnick v.[lindex $::version 0], Tcl v.[info patchlevel]</center>"
	puts $writefile "<center>$conf(game_info)</center>"
	puts $writefile "<center> : [countusers], : $conf(maxtop).</center>"
	puts $writefile "</center></body></html>"

	close $writefile	
	
	unset maxtop
	#sendftp						
}
